﻿using System;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;
using MarkII.Managers;
using MarkII.Misc;
using System.Xml.Linq;
using MarkII.Settings;
using Styx;
using Styx.Common;

namespace MarkII.GUI
{
    public partial class ConfigurationForm : Form
    {
        public ConfigurationForm()
        {
            InitializeComponent();
            Text = "Mark II";

            //Focus Key
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton1, "Mouse button 4"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton2, "Mouse button 5"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D1, "1 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D2, "2 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D3, "3 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D4, "4 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D5, "5 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D6, "6 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D7, "7 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D8, "8 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D9, "9 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D0, "0 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad1, "1 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad2, "2 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad3, "3 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad4, "4 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad5, "5 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad6, "6 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad7, "7 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad8, "8 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad9, "9 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad0, "0 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F1, "F1"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F2, "F2"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F3, "F3"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F4, "F4"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F5, "F5"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F6, "F6"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F7, "F7"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F8, "F8"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F9, "F9"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F10, "F10"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F11, "F11"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F12, "F12"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.Q, "Q"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.E, "E"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.P, "P"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.R, "R"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.Z, "Z"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.X, "X"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.C, "C"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.V, "V"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.B, "B"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F, "F"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.T, "T"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.G, "G"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.Menu, "Generic Alt"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.RMenu, "Right Alt"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.LMenu, "Left Alt"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.ControlKey, "Generic CTRL"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.RControlKey, "Right CTRL"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.LControlKey, "Left CTRL"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.ShiftKey, "Generic Shift"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.RShiftKey, "Right Shift"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.LShiftKey, "Left Shift"));

            //Auto Key
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton1, "Mouse button 4"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton2, "Mouse button 5"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.D1, "1 (no numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.D2, "2 (no numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.D3, "3 (no numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.D4, "4 (no numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.D5, "5 (no numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.D6, "6 (no numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.D7, "7 (no numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.D8, "8 (no numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.D9, "9 (no numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.D0, "0 (no numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad1, "1 (numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad2, "2 (numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad3, "3 (numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad4, "4 (numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad5, "5 (numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad6, "6 (numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad7, "7 (numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad8, "8 (numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad9, "9 (numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad0, "0 (numpad)"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.F1, "F1"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.F2, "F2"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.F3, "F3"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.F4, "F4"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.F5, "F5"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.F6, "F6"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.F7, "F7"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.F8, "F8"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.F9, "F9"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.F10, "F10"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.F11, "F11"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.F12, "F12"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.Q, "Q"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.E, "E"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.P, "P"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.R, "R"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.Z, "Z"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.X, "X"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.C, "C"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.V, "V"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.B, "B"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.F, "F"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.T, "T"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.G, "G"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.Menu, "Generic Alt"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.RMenu, "Right Alt"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.LMenu, "Left Alt"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.ControlKey, "Generic CTRL"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.RControlKey, "Right CTRL"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.LControlKey, "Left CTRL"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.ShiftKey, "Generic Shift"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.RShiftKey, "Right Shift"));
            AutoKeys.Items.Add(new Extensions.CboItem((int)Keys.LShiftKey, "Left Shift"));

            //MultiDot
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton1, "Mouse button 4"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton2, "Mouse button 5"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D1, "1 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D2, "2 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D3, "3 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D4, "4 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D5, "5 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D6, "6 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D7, "7 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D8, "8 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D9, "9 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D0, "0 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad1, "1 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad2, "2 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad3, "3 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad4, "4 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad5, "5 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad6, "6 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad7, "7 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad8, "8 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad9, "9 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad0, "0 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F1, "F1"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F2, "F2"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F3, "F3"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F4, "F4"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F5, "F5"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F6, "F6"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F7, "F7"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F8, "F8"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F9, "F9"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F10, "F10"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F11, "F11"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F12, "F12"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.Q, "Q"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.E, "E"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.P, "P"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.R, "R"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.Z, "Z"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.X, "X"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.C, "C"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.V, "V"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.B, "B"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F, "F"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.T, "T"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.G, "G"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.Menu, "Generic Alt"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.RMenu, "Right Alt"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.LMenu, "Left Alt"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.ControlKey, "Generic CTRL"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.RControlKey, "Right CTRL"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.LControlKey, "Left CTRL"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.ShiftKey, "Generic Shift"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.RShiftKey, "Right Shift"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.LShiftKey, "Left Shift"));

            //AoE Key
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton1, "Mouse button 4"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton2, "Mouse button 5"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D1, "1 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D2, "2 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D3, "3 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D4, "4 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D5, "5 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D6, "6 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D7, "7 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D8, "8 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D9, "9 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D0, "0 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad1, "1 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad2, "2 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad3, "3 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad4, "4 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad5, "5 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad6, "6 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad7, "7 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad8, "8 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad9, "9 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad0, "0 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F1, "F1"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F2, "F2"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F3, "F3"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F4, "F4"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F5, "F5"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F6, "F6"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F7, "F7"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F8, "F8"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F9, "F9"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F10, "F10"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F11, "F11"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F12, "F12"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.Q, "Q"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.E, "E"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.P, "P"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.R, "R"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.Z, "Z"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.X, "X"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.C, "C"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.V, "V"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.B, "B"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F, "F"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.T, "T"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.G, "G"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.Menu, "Generic Alt"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.RMenu, "Right Alt"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.LMenu, "Left Alt"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.ControlKey, "Generic CTRL"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.RControlKey, "Right CTRL"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.LControlKey, "Left CTRL"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.ShiftKey, "Generic Shift"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.RShiftKey, "Right Shift"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.LShiftKey, "Left Shift"));

            //CrowdControl key
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton1, "Mouse button 4"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton2, "Mouse button 5"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D1, "1 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D2, "2 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D3, "3 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D4, "4 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D5, "5 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D6, "6 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D7, "7 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D8, "8 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D9, "9 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D0, "0 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad1, "1 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad2, "2 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad3, "3 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad4, "4 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad5, "5 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad6, "6 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad7, "7 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad8, "8 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad9, "9 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad0, "0 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F1, "F1"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F2, "F2"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F3, "F3"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F4, "F4"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F5, "F5"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F6, "F6"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F7, "F7"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F8, "F8"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F9, "F9"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F10, "F10"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F11, "F11"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F12, "F12"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.Q, "Q"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.E, "E"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.P, "P"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.R, "R"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.Z, "Z"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.X, "X"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.C, "C"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.V, "V"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.B, "B"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F, "F"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.T, "T"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.G, "G"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.Menu, "Generic Alt"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.RMenu, "Right Alt"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.LMenu, "Left Alt"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.ControlKey, "Generic CTRL"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.RControlKey, "Right CTRL"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.LControlKey, "Left CTRL"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.ShiftKey, "Generic Shift"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.RShiftKey, "Right Shift"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.LShiftKey, "Left Shift"));

            //CrowdControl key
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton1, "Mouse button 4"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton2, "Mouse button 5"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D1, "1 (no numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D2, "2 (no numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D3, "3 (no numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D4, "4 (no numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D5, "5 (no numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D6, "6 (no numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D7, "7 (no numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D8, "8 (no numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D9, "9 (no numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D0, "0 (no numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad1, "1 (numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad2, "2 (numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad3, "3 (numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad4, "4 (numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad5, "5 (numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad6, "6 (numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad7, "7 (numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad8, "8 (numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad9, "9 (numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad0, "0 (numpad)"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F1, "F1"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F2, "F2"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F3, "F3"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F4, "F4"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F5, "F5"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F6, "F6"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F7, "F7"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F8, "F8"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F9, "F9"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F10, "F10"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F11, "F11"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F12, "F12"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.Q, "Q"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.E, "E"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.P, "P"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.R, "R"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.Z, "Z"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.X, "X"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.C, "C"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.V, "V"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.B, "B"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F, "F"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.T, "T"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.G, "G"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.Menu, "Generic Alt"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.RMenu, "Right Alt"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.LMenu, "Left Alt"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.ControlKey, "Generic CTRL"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.RControlKey, "Right CTRL"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.LControlKey, "Left CTRL"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.ShiftKey, "Generic Shift"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.RShiftKey, "Right Shift"));
            PauseModeKeys.Items.Add(new Extensions.CboItem((int)Keys.LShiftKey, "Left Shift"));

            //CrowdControl key
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton1, "Mouse button 4"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton2, "Mouse button 5"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D1, "1 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D2, "2 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D3, "3 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D4, "4 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D5, "5 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D6, "6 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D7, "7 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D8, "8 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D9, "9 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D0, "0 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad1, "1 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad2, "2 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad3, "3 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad4, "4 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad5, "5 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad6, "6 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad7, "7 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad8, "8 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad9, "9 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad0, "0 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F1, "F1"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F2, "F2"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F3, "F3"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F4, "F4"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F5, "F5"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F6, "F6"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F7, "F7"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F8, "F8"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F9, "F9"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F10, "F10"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F11, "F11"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F12, "F12"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.Q, "Q"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.E, "E"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.P, "P"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.R, "R"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.Z, "Z"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.X, "X"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.C, "C"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.V, "V"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.B, "B"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F, "F"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.T, "T"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.G, "G"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.Menu, "Generic Alt"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.RMenu, "Right Alt"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.LMenu, "Left Alt"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.ControlKey, "Generic CTRL"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.RControlKey, "Right CTRL"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.LControlKey, "Left CTRL"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.ShiftKey, "Generic Shift"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.RShiftKey, "Right Shift"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.LShiftKey, "Left Shift"));

            //Modechoice
            ModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Alt, "Alt"));
            ModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Control, "Control (Strg)"));
            ModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Shift, "Shift"));
            ModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.None, "None"));

            MultiDotModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Alt, "Alt"));
            MultiDotModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Control, "Control (Strg)"));
            MultiDotModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Shift, "Shift"));
            MultiDotModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.None, "None"));

            FocusModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Alt, "Alt"));
            FocusModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Control, "Control (Strg)"));
            FocusModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Shift, "Shift"));
            FocusModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.None, "None"));

            AutoModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Alt, "Alt"));
            AutoModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Control, "Control (Strg)"));
            AutoModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Shift, "Shift"));
            AutoModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.None, "None"));

            CCModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.LMenu, "Left Alt"));
            CCModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.LControlKey, "Left CTRL"));
            CCModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.LShiftKey, "Left Shift"));
            CCModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.None, "None"));

            PauseModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.LMenu, "Left Alt"));
            PauseModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.LControlKey, "Left CTRL"));
            PauseModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.LShiftKey, "Left Shift"));
            PauseModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.None, "None"));


            Extensions.CboItem.SetComboBoxEnum(FocusKeys, (int)MainSettings.Hotkeys.Instance.FocusKeyChoice);
            Extensions.CboItem.SetComboBoxEnum(AutoKeys, (int)MainSettings.Hotkeys.Instance.AutoKeyChoice);
            Extensions.CboItem.SetComboBoxEnum(MultiDotKeys, (int)MainSettings.Hotkeys.Instance.MultiDotKeyChoice);
            Extensions.CboItem.SetComboBoxEnum(CCModeKeys, (int)MainSettings.Hotkeys.Instance.CCModeKeyChoice);
            Extensions.CboItem.SetComboBoxEnum(PauseModeKeys, (int)MainSettings.Hotkeys.Instance.PauseModeKeyChoice);
            Extensions.CboItem.SetComboBoxEnum(ForceTrapKeys, (int)MainSettings.Hotkeys.Instance.ForceTrapChoice);
            Extensions.CboItem.SetComboBoxEnum(AoEKeys, (int)MainSettings.Hotkeys.Instance.AoEKeyChoice);

            Extensions.CboItem.SetComboBoxEnum(CCModifierChoice, (int)MainSettings.Hotkeys.Instance.CCModifierChoice);
            Extensions.CboItem.SetComboBoxEnum(PauseModifierChoice, (int)MainSettings.Hotkeys.Instance.PauseModifierChoice);
            Extensions.CboItem.SetComboBoxEnum(ModifierChoice, (int)MainSettings.Hotkeys.Instance.ModifierChoice);
            Extensions.CboItem.SetComboBoxEnum(AutoModifierChoice, (int)MainSettings.Hotkeys.Instance.AutoModifierChoice);
            Extensions.CboItem.SetComboBoxEnum(FocusModifierChoice, (int)MainSettings.Hotkeys.Instance.FocusModifierChoice);
            Extensions.CboItem.SetComboBoxEnum(MultiDotModifierChoice, (int)MainSettings.Hotkeys.Instance.MultiDotModifierChoice);
        }

        public override sealed string Text
        {
            get { return base.Text; }
            set { base.Text = value; }
        }

        #region Category: Hotkeys
        private void ModifierChoice_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            if (MainSettings.Hotkeys.Instance != null)
                MainSettings.Hotkeys.Instance.ModifierChoice = (ModifierKeys)Extensions.CboItem.GetComboBoxEnum(ModifierChoice);
        }

        private void FocusKeys_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            if (MainSettings.Hotkeys.Instance != null)
                MainSettings.Hotkeys.Instance.FocusKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(FocusKeys);
        }

        private void AutoKeys_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (MainSettings.Hotkeys.Instance != null)
                MainSettings.Hotkeys.Instance.AutoKeyChoice = (Keys) Extensions.CboItem.GetComboBoxEnum(AutoKeys);
        }

        private void CCModeKeys_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            if (MainSettings.Hotkeys.Instance != null)
                MainSettings.Hotkeys.Instance.CCModeKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(CCModeKeys);
        }

        private void PauseModeKeys_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (MainSettings.Hotkeys.Instance != null)
                MainSettings.Hotkeys.Instance.PauseModeKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(PauseModeKeys);
        }

        private void ForceTrapKeys_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (MainSettings.Hotkeys.Instance != null)
                MainSettings.Hotkeys.Instance.ForceTrapChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(ForceTrapKeys);
        }

        private void AoEKeys_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            if (MainSettings.Hotkeys.Instance != null)
                MainSettings.Hotkeys.Instance.AoEKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(AoEKeys);
        }

        private void FocusModifierChoice_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (MainSettings.Hotkeys.Instance != null)
                MainSettings.Hotkeys.Instance.FocusModifierChoice = (ModifierKeys)Extensions.CboItem.GetComboBoxEnum(FocusModifierChoice);
        }

        private void AutoModifierChoice_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (MainSettings.Hotkeys.Instance != null)
                MainSettings.Hotkeys.Instance.AutoModifierChoice = (ModifierKeys)Extensions.CboItem.GetComboBoxEnum(AutoModifierChoice);
        }

        private void CCModifierChoice_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (MainSettings.Hotkeys.Instance != null)
                MainSettings.Hotkeys.Instance.CCModifierChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(CCModifierChoice);
        }

        private void PauseModifierChoice_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (MainSettings.Hotkeys.Instance != null)
                MainSettings.Hotkeys.Instance.PauseModifierChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(PauseModifierChoice);
        }

        private void MultiDotModifierChoice_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (MainSettings.Hotkeys.Instance != null)
                MainSettings.Hotkeys.Instance.MultiDotModifierChoice = (ModifierKeys)Extensions.CboItem.GetComboBoxEnum(MultiDotModifierChoice);
        }

        private void MultiDotKeys_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (MainSettings.Hotkeys.Instance != null)
                MainSettings.Hotkeys.Instance.MultiDotKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(MultiDotKeys);
        }

        #endregion

        private void ConfigurationFormLoad(object sender, EventArgs e)
        {
            pMain.SelectedObject = MainSettings.Instance;
            pMainPvP.SelectedObject = MainSettingsPvP.Instance;
            pPet.SelectedObject = PetSettings.Instance;
            pPetPvP.SelectedObject = PetSettingsPvP.Instance;
            pCooldowns.SelectedObject = CooldownSettings.Instance;
            pCooldownsPvP.SelectedObject = CooldownSettingsPvP.Instance;
            InitializeStyle();
        }

        #region Menu ToolStrip

        private void SaveToolStripMenuItemClick(object sender, EventArgs e)
        {
            MainSettings.Instance.Save();
            MainSettingsPvP.Instance.Save();
            PetSettings.Instance.Save();
            PetSettingsPvP.Instance.Save();
            CooldownSettings.Instance.Save();
            CooldownSettingsPvP.Instance.Save();
            MainSettings.Hotkeys.Instance.Save();

                //Hotkey Stuff
                MainSettings.Hotkeys.Instance.CCModeKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(CCModeKeys);
                MainSettings.Hotkeys.Instance.PauseModeKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(PauseModeKeys);
                MainSettings.Hotkeys.Instance.ForceTrapChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(ForceTrapKeys);
                MainSettings.Hotkeys.Instance.AoEKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(AoEKeys);
                MainSettings.Hotkeys.Instance.MultiDotKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(MultiDotKeys);
                MainSettings.Hotkeys.Instance.FocusKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(FocusKeys);
                MainSettings.Hotkeys.Instance.AutoKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(AutoKeys);


                MainSettings.Hotkeys.Instance.ModifierChoice = (ModifierKeys)Extensions.CboItem.GetComboBoxEnum(ModifierChoice);
                MainSettings.Hotkeys.Instance.PauseModifierChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(PauseModifierChoice);
                MainSettings.Hotkeys.Instance.FocusModifierChoice = (ModifierKeys)Extensions.CboItem.GetComboBoxEnum(FocusModifierChoice);
                MainSettings.Hotkeys.Instance.AutoModifierChoice = (ModifierKeys)Extensions.CboItem.GetComboBoxEnum(AutoModifierChoice);
                MainSettings.Hotkeys.Instance.MultiDotModifierChoice = (ModifierKeys)Extensions.CboItem.GetComboBoxEnum(MultiDotModifierChoice);
            

            HotkeyManager.RemoveAllKeys();
            StyxWoW.SleepForLagDuration();
            HotkeyManager.RegisterKeys();

            Close();
            Logger.InitLog("Settings Saved");
        }

        private void CloseToolStripMenuItemClick(object sender, EventArgs e)
        {
            Close();
        }

        private void ThreadToolStripMenuItemClick(object sender, EventArgs e)
        {
            try
            { //TODO: CHange the Link
                Process.Start("http://www.thebuddyforum.com/honorbuddy-forum/combat-routines/hunter/107930-mark-i-user-controlled-pve-pvp-hunter-routine.html");
            }

            catch (Exception u)
            {
                Console.WriteLine(u.Message);
            }
        }

        private void ChangeLogToolStripMenuItemClick(object sender, EventArgs e)
        {
            try
            { //TODO: CHange the Link
                Process.Start("https://www.assembla.com/spaces/mark-i/stream");
            }

            catch (Exception u)
            {
                Console.WriteLine(u.Message);
            }
        }

        #endregion
        
        private static string UsercPath
        {
            get
            {
                return string.Format("{0}\\Routines\\Mark II\\Settings\\MarkISettings_", Utilities.AssemblyDirectory);
            }
        }

        
        #region GUI Styling

        private void InitializeStyle()
        { 

            //Menu Toolstrip
            presetsToolStripMenuItem.ForeColor = Color.SeaGreen; //Text
            SaveToolStripMenuItem.ForeColor = Color.SeaGreen; //Text
            CloseToolStripMenuItem.ForeColor = Color.SeaGreen;//Text
            ThreadToolStripMenuItem.ForeColor = Color.SeaGreen;//Text
            ChangeLogToolStripMenuItem.ForeColor = Color.SeaGreen;//Text
            HelpToolStripMenuItem.ForeColor = Color.SeaGreen;//Text
            //menuStrip1.BackColor = Color.GhostWhite; //Background
            
            //Main Property Grid
            //pMain.HelpBackColor = Color.FromArgb(45, 45, 48); // Description
            pMain.HelpForeColor = Color.Black;// Description
            //pMain.BackColor = Color.FromArgb(45, 45, 48); // Category
            pMain.ForeColor = Color.SeaGreen; // Category
            //pMain.LineColor = Color.FromArgb(45, 45, 48); // Category
            pMain.CategoryForeColor = Color.SeaGreen;  //Text
            //pMain.ViewBackColor = Color.FromArgb(45, 45, 48); // properties
            pMain.ViewForeColor = Color.Black; // properties
            pMain.ToolbarVisible = false; // show toolbar
            pMain.CollapseAllGridItems(); //collapse all Category
            pMain.PerformAutoScale(); //Scale that shit

            //Main PvP Property Grid
            //pMainPvP.HelpBackColor = Color.FromArgb(45, 45, 48); // Description
            pMainPvP.HelpForeColor = Color.Black;// Description
            //pMainPvP.BackColor = Color.FromArgb(45, 45, 48); // Category
            pMainPvP.ForeColor = Color.SeaGreen; // Category
            //pMainPvP.LineColor = Color.FromArgb(45, 45, 48); // Category
            pMainPvP.CategoryForeColor = Color.SeaGreen;  //Text
            //pMainPvP.ViewBackColor = Color.FromArgb(45, 45, 48); // properties
            pMainPvP.ViewForeColor = Color.Black; // properties
            pMainPvP.ToolbarVisible = false; // show toolbar
            pMainPvP.CollapseAllGridItems(); //collapse all Category
            pMainPvP.PerformAutoScale(); //Scale that shit

            //Pet Property Grid
            //pPet.HelpBackColor = Color.FromArgb(45, 45, 48); // Description
            pPet.HelpForeColor = Color.Black;// Description
            //pPet.BackColor = Color.FromArgb(45, 45, 48); // Category
            pPet.ForeColor = Color.SeaGreen; // Category
            //pPet.LineColor = Color.FromArgb(45, 45, 48); // Category
            pPet.CategoryForeColor = Color.SeaGreen;  //Text
            //pPet.ViewBackColor = Color.FromArgb(45, 45, 48); // properties
            pPet.ViewForeColor = Color.Black; // properties
            pPet.ToolbarVisible = false; // show toolbar
            //pPet.CollapseAllGridItems(); //collapse all Category
            pPet.PerformAutoScale();

            //Cooldown Property Grid
            //pPet.HelpBackColor = Color.FromArgb(45, 45, 48); // Description
            pCooldowns.HelpForeColor = Color.Black;// Description
            //pPet.BackColor = Color.FromArgb(45, 45, 48); // Category
            pCooldowns.ForeColor = Color.SeaGreen; // Category
            //pPet.LineColor = Color.FromArgb(45, 45, 48); // Category
            pCooldowns.CategoryForeColor = Color.SeaGreen;  //Text
            //pPet.ViewBackColor = Color.FromArgb(45, 45, 48); // properties
            pCooldowns.ViewForeColor = Color.Black; // properties
            pCooldowns.ToolbarVisible = false; // show toolbar
            //pPet.CollapseAllGridItems(); //collapse all Category
            pCooldowns.PerformAutoScale();

            //Pet Property Grid
            //pPetPvP.HelpBackColor = Color.FromArgb(45, 45, 48); // Description
            pPetPvP.HelpForeColor = Color.Black;// Description
            //pPetPvP.BackColor = Color.FromArgb(45, 45, 48); // Category
            pPetPvP.ForeColor = Color.SeaGreen; // Category
            //pPetPvP.LineColor = Color.FromArgb(45, 45, 48); // Category
            pPetPvP.CategoryForeColor = Color.SeaGreen;  //Text
            //pPetPvP.ViewBackColor = Color.FromArgb(45, 45, 48); // properties
            pPetPvP.ViewForeColor = Color.Black; // properties
            pPetPvP.ToolbarVisible = false; // show toolbar
            //pPetPvP.CollapseAllGridItems(); //collapse all Category
            pPetPvP.PerformAutoScale();

            //Cooldown Property Grid
            //pCooldownsPvP.HelpBackColor = Color.FromArgb(45, 45, 48); // Description
            pCooldownsPvP.HelpForeColor = Color.Black;// Description
            //pCooldownsPvP.BackColor = Color.FromArgb(45, 45, 48); // Category
            pCooldownsPvP.ForeColor = Color.SeaGreen; // Category
            //pCooldownsPvP.LineColor = Color.FromArgb(45, 45, 48); // Category
            pCooldownsPvP.CategoryForeColor = Color.SeaGreen;  //Text
            //pCooldownsPvP.ViewBackColor = Color.FromArgb(45, 45, 48); // properties
            pCooldownsPvP.ViewForeColor = Color.Black; // properties
            pCooldownsPvP.ToolbarVisible = false; // show toolbar
            //pCooldownsPvP.CollapseAllGridItems(); //collapse all Category
            pCooldownsPvP.PerformAutoScale();

        }

        #endregion

        private void SaveSlot1Click_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Mark II has successfully saved your settings.", "Settings", MessageBoxButtons.OK, MessageBoxIcon.Information);
            Logger.InitLog(@"--------<-[Slot #1] Settings Saved->---------");
            MainSettings.Instance.SaveToFile(UsercPath + "Slot1.config");
        }

        private void LoadSlot1Click_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Mark II has successfully loaded your settings.", "Settings", MessageBoxButtons.OK, MessageBoxIcon.Information);
            Logger.InitLog(@"--------<-[Slot #1] Settings Loaded->---------");
            MainSettings.Instance.LoadFromXML(XElement.Load(UsercPath + "Slot1.config"));
        }

        private void SaveSlot2Click_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Mark II has successfully saved your settings.", "Settings", MessageBoxButtons.OK, MessageBoxIcon.Information);
            Logger.InitLog(@"--------<-[Slot #2] Settings Saved->---------");
            MainSettings.Instance.SaveToFile(UsercPath + "Slot2.config");
        }

        private void LoadSlot2Click_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Mark II has successfully loaded your settings.", "Settings", MessageBoxButtons.OK, MessageBoxIcon.Information);
            Logger.InitLog(@"--------<-[Slot #2] Settings Loaded->---------");
            MainSettings.Instance.LoadFromXML(XElement.Load(UsercPath + "Slot2.config"));
        }

        private void SaveSlot3Click_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Mark II has successfully saved your settings.", "Settings", MessageBoxButtons.OK, MessageBoxIcon.Information);
            Logger.InitLog(@"--------<-[Slot #3] Settings Saved->---------");
            MainSettings.Instance.SaveToFile(UsercPath + "Slot3.config");
        }

        private void LoadSlot3Click_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Mark II has successfully loaded your settings.", "Settings", MessageBoxButtons.OK, MessageBoxIcon.Information);
            Logger.InitLog(@"--------<-[Slot #3] Settings Loaded->---------");
            MainSettings.Instance.LoadFromXML(XElement.Load(UsercPath + "Slot3.config"));
        }

        private void arenaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MainSettingsPvP.Instance.ForcePvP = true;
        }

        private void battlegroundToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MainSettingsPvP.Instance.ForcePvP = false;
        }
    }
}
