﻿using System;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;
using MarkII.Managers;
using MarkII.Misc;
using System.Xml.Linq;
using MarkII.Settings;
using Styx;
using Styx.Common;

namespace MarkII.GUI
{
    public partial class ConfigurationFormSV : Form
    {
        public ConfigurationFormSV()
        {
            InitializeComponent();
            Text = "Mark II";

            //Focus Key
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton1, "Mouse button 4"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton2, "Mouse button 5"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D1, "1 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D2, "2 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D3, "3 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D4, "4 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D5, "5 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D6, "6 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D7, "7 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D8, "8 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D9, "9 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.D0, "0 (no numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad1, "1 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad2, "2 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad3, "3 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad4, "4 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad5, "5 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad6, "6 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad7, "7 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad8, "8 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad9, "9 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad0, "0 (numpad)"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F1, "F1"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F2, "F2"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F3, "F3"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F4, "F4"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F5, "F5"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F6, "F6"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F7, "F7"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F8, "F8"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F9, "F9"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F10, "F10"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F11, "F11"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F12, "F12"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.Q, "Q"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.E, "E"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.P, "P"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.R, "R"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.Z, "Z"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.X, "X"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.C, "C"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.V, "V"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.B, "B"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.F, "F"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.T, "T"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.G, "G"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.Menu, "Generic Alt"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.RMenu, "Right Alt"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.LMenu, "Left Alt"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.ControlKey, "Generic CTRL"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.RControlKey, "Right CTRL"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.LControlKey, "Left CTRL"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.ShiftKey, "Generic Shift"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.RShiftKey, "Right Shift"));
            FocusKeys.Items.Add(new Extensions.CboItem((int)Keys.LShiftKey, "Left Shift"));

            //MultiDot
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton1, "Mouse button 4"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton2, "Mouse button 5"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D1, "1 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D2, "2 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D3, "3 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D4, "4 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D5, "5 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D6, "6 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D7, "7 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D8, "8 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D9, "9 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.D0, "0 (no numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad1, "1 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad2, "2 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad3, "3 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad4, "4 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad5, "5 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad6, "6 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad7, "7 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad8, "8 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad9, "9 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad0, "0 (numpad)"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F1, "F1"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F2, "F2"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F3, "F3"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F4, "F4"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F5, "F5"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F6, "F6"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F7, "F7"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F8, "F8"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F9, "F9"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F10, "F10"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F11, "F11"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F12, "F12"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.Q, "Q"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.E, "E"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.P, "P"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.R, "R"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.Z, "Z"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.X, "X"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.C, "C"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.V, "V"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.B, "B"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.F, "F"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.T, "T"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.G, "G"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.Menu, "Generic Alt"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.RMenu, "Right Alt"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.LMenu, "Left Alt"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.ControlKey, "Generic CTRL"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.RControlKey, "Right CTRL"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.LControlKey, "Left CTRL"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.ShiftKey, "Generic Shift"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.RShiftKey, "Right Shift"));
            MultiDotKeys.Items.Add(new Extensions.CboItem((int)Keys.LShiftKey, "Left Shift"));

            //AoE Key
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton1, "Mouse button 4"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton2, "Mouse button 5"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D1, "1 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D2, "2 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D3, "3 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D4, "4 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D5, "5 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D6, "6 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D7, "7 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D8, "8 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D9, "9 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.D0, "0 (no numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad1, "1 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad2, "2 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad3, "3 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad4, "4 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad5, "5 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad6, "6 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad7, "7 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad8, "8 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad9, "9 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad0, "0 (numpad)"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F1, "F1"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F2, "F2"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F3, "F3"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F4, "F4"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F5, "F5"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F6, "F6"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F7, "F7"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F8, "F8"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F9, "F9"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F10, "F10"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F11, "F11"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F12, "F12"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.Q, "Q"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.E, "E"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.P, "P"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.R, "R"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.Z, "Z"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.X, "X"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.C, "C"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.V, "V"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.B, "B"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.F, "F"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.T, "T"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.G, "G"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.Menu, "Generic Alt"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.RMenu, "Right Alt"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.LMenu, "Left Alt"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.ControlKey, "Generic CTRL"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.RControlKey, "Right CTRL"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.LControlKey, "Left CTRL"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.ShiftKey, "Generic Shift"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.RShiftKey, "Right Shift"));
            AoEKeys.Items.Add(new Extensions.CboItem((int)Keys.LShiftKey, "Left Shift"));

            //CrowdControl key
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton1, "Mouse button 4"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton2, "Mouse button 5"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D1, "1 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D2, "2 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D3, "3 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D4, "4 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D5, "5 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D6, "6 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D7, "7 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D8, "8 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D9, "9 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.D0, "0 (no numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad1, "1 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad2, "2 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad3, "3 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad4, "4 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad5, "5 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad6, "6 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad7, "7 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad8, "8 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad9, "9 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad0, "0 (numpad)"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F1, "F1"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F2, "F2"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F3, "F3"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F4, "F4"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F5, "F5"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F6, "F6"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F7, "F7"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F8, "F8"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F9, "F9"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F10, "F10"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F11, "F11"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F12, "F12"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.Q, "Q"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.E, "E"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.P, "P"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.R, "R"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.Z, "Z"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.X, "X"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.C, "C"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.V, "V"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.B, "B"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.F, "F"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.T, "T"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.G, "G"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.Menu, "Generic Alt"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.RMenu, "Right Alt"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.LMenu, "Left Alt"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.ControlKey, "Generic CTRL"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.RControlKey, "Right CTRL"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.LControlKey, "Left CTRL"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.ShiftKey, "Generic Shift"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.RShiftKey, "Right Shift"));
            CCModeKeys.Items.Add(new Extensions.CboItem((int)Keys.LShiftKey, "Left Shift"));

            //CrowdControl key
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton1, "Mouse button 4"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.XButton2, "Mouse button 5"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D1, "1 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D2, "2 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D3, "3 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D4, "4 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D5, "5 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D6, "6 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D7, "7 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D8, "8 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D9, "9 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.D0, "0 (no numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad1, "1 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad2, "2 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad3, "3 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad4, "4 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad5, "5 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad6, "6 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad7, "7 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad8, "8 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad9, "9 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.NumPad0, "0 (numpad)"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F1, "F1"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F2, "F2"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F3, "F3"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F4, "F4"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F5, "F5"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F6, "F6"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F7, "F7"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F8, "F8"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F9, "F9"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F10, "F10"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F11, "F11"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F12, "F12"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.Q, "Q"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.E, "E"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.P, "P"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.R, "R"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.Z, "Z"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.X, "X"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.C, "C"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.V, "V"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.B, "B"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.F, "F"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.T, "T"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.G, "G"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.Menu, "Generic Alt"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.RMenu, "Right Alt"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.LMenu, "Left Alt"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.ControlKey, "Generic CTRL"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.RControlKey, "Right CTRL"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.LControlKey, "Left CTRL"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.ShiftKey, "Generic Shift"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.RShiftKey, "Right Shift"));
            ForceTrapKeys.Items.Add(new Extensions.CboItem((int)Keys.LShiftKey, "Left Shift"));

            //Modechoice
            ModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Alt, "Alt"));
            ModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Control, "Control (Strg)"));
            ModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Shift, "Shift"));
            ModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.None, "None"));

            FocusModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Alt, "Alt"));
            FocusModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Control, "Control (Strg)"));
            FocusModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Shift, "Shift"));
            FocusModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.None, "None"));

            MultiDotModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Alt, "Alt"));
            MultiDotModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Control, "Control (Strg)"));
            MultiDotModifierChoice.Items.Add(new Extensions.CboItem((int)Styx.Common.ModifierKeys.Shift, "Shift"));
            MultiDotModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.None, "None"));

            CCModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.LMenu, "Left Alt"));
            CCModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.LControlKey, "Left CTRL"));
            CCModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.LShiftKey, "Left Shift"));
            CCModifierChoice.Items.Add(new Extensions.CboItem((int)Keys.None, "None"));


            Extensions.CboItem.SetComboBoxEnum(FocusKeys, (int)MainSettingsSV.Hotkeys.Instance.FocusKeyChoice);
            Extensions.CboItem.SetComboBoxEnum(CCModeKeys, (int)MainSettingsSV.Hotkeys.Instance.CCModeKeyChoice);
            Extensions.CboItem.SetComboBoxEnum(ForceTrapKeys, (int)MainSettingsSV.Hotkeys.Instance.ForceTrapChoice);
            Extensions.CboItem.SetComboBoxEnum(AoEKeys, (int)MainSettingsSV.Hotkeys.Instance.AoEKeyChoice);
            Extensions.CboItem.SetComboBoxEnum(MultiDotKeys, (int)MainSettingsSV.Hotkeys.Instance.MultiDotKeyChoice);

            Extensions.CboItem.SetComboBoxEnum(CCModifierChoice, (int)MainSettingsSV.Hotkeys.Instance.CCModifierChoice);
            Extensions.CboItem.SetComboBoxEnum(ModifierChoice, (int)MainSettingsSV.Hotkeys.Instance.ModifierChoice);
            Extensions.CboItem.SetComboBoxEnum(FocusModifierChoice, (int)MainSettingsSV.Hotkeys.Instance.FocusModifierChoice);
            Extensions.CboItem.SetComboBoxEnum(MultiDotModifierChoice, (int)MainSettingsSV.Hotkeys.Instance.MultiDotModifierChoice);
        }

        public override sealed string Text
        {
            get { return base.Text; }
            set { base.Text = value; }
        }

        #region Category: Hotkeys


        private void CCModifierChoice_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            MainSettingsSV.Hotkeys.Instance.CCModifierChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(CCModifierChoice);
        }
        private void CCModeKeys_SelectedIndexChanged(object sender, EventArgs e)
        {
            MainSettingsSV.Hotkeys.Instance.CCModeKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(CCModeKeys);
        }

        private void ForceTrapKeys_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            MainSettingsSV.Hotkeys.Instance.ForceTrapChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(ForceTrapKeys);
        }

        private void AoEKeys_SelectedIndexChanged(object sender, EventArgs e)
        {
            MainSettingsSV.Hotkeys.Instance.AoEKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(AoEKeys);
        }

        private void ModifierChoice_SelectedIndexChanged(object sender, EventArgs e)
        {
            MainSettingsSV.Hotkeys.Instance.ModifierChoice = (ModifierKeys)Extensions.CboItem.GetComboBoxEnum(ModifierChoice);
        }

        private void FocusModifierChoice_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            MainSettingsSV.Hotkeys.Instance.FocusModifierChoice = (ModifierKeys)Extensions.CboItem.GetComboBoxEnum(FocusModifierChoice);
        }

        private void FocusKeys_SelectedIndexChanged(object sender, EventArgs e)
        {
            MainSettingsSV.Hotkeys.Instance.FocusKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(FocusKeys);
        }

        private void MultiDotModifierChoice_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (MainSettingsSV.Hotkeys.Instance != null)
                MainSettingsSV.Hotkeys.Instance.MultiDotModifierChoice = (ModifierKeys)Extensions.CboItem.GetComboBoxEnum(MultiDotModifierChoice);
        }

        private void MultiDotKeys_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (MainSettingsSV.Hotkeys.Instance != null)
                MainSettingsSV.Hotkeys.Instance.MultiDotKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(MultiDotKeys);
        }
      
        #endregion

        private void ConfigurationFormSVLoad(object sender, EventArgs e)
        {
            pMain.SelectedObject = MainSettingsSV.Instance;
            pPet.SelectedObject = PetSettingsSV.Instance;
            pCooldowns.SelectedObject = CooldownSettingsSV.Instance;

            InitializeStyle();
        }

        #region Menu ToolStrip

        private void SaveToolStripMenuItemClick(object sender, EventArgs e)
        {
            MainSettingsSV.Instance.Save();
            PetSettingsSV.Instance.Save();
            CooldownSettingsSV.Instance.Save();
            MainSettingsSV.Hotkeys.Instance.Save();

            //Hotkey Stuff
            MainSettingsSV.Hotkeys.Instance.CCModeKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(CCModeKeys);
            MainSettingsSV.Hotkeys.Instance.ForceTrapChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(ForceTrapKeys);
            MainSettingsSV.Hotkeys.Instance.AoEKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(AoEKeys);
            MainSettingsSV.Hotkeys.Instance.FocusKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(FocusKeys);
            MainSettingsSV.Hotkeys.Instance.MultiDotKeyChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(MultiDotKeys);

            MainSettingsSV.Hotkeys.Instance.ModifierChoice = (ModifierKeys)Extensions.CboItem.GetComboBoxEnum(ModifierChoice);
            MainSettingsSV.Hotkeys.Instance.CCModifierChoice = (Keys)Extensions.CboItem.GetComboBoxEnum(CCModifierChoice);
            MainSettingsSV.Hotkeys.Instance.FocusModifierChoice = (ModifierKeys)Extensions.CboItem.GetComboBoxEnum(FocusModifierChoice);
            MainSettingsSV.Hotkeys.Instance.MultiDotModifierChoice = (ModifierKeys)Extensions.CboItem.GetComboBoxEnum(MultiDotModifierChoice);

            HotkeyManager.RemoveAllKeys();
            StyxWoW.SleepForLagDuration();
            HotkeyManager.RegisterKeys();

            Close();
            Logger.InitLog("Settings Saved");
        }

        private void CloseToolStripMenuItemClick(object sender, EventArgs e)
        {
            Close();
        }

        private void ThreadToolStripMenuItemClick(object sender, EventArgs e)
        {
            try
            { 
                Process.Start("http://www.thebuddyforum.com/honorbuddy-forum/combat-routines/hunter/107930-mark-i-user-controlled-pve-pvp-hunter-routine.html");
            }

            catch (Exception u)
            {
                Console.WriteLine(u.Message);
            }
        }

        private void ChangeLogToolStripMenuItemClick(object sender, EventArgs e)
        {
            try
            { //TODO: CHange the Link
                Process.Start("https://www.assembla.com/spaces/mark-i/stream");
            }

            catch (Exception u)
            {
                Console.WriteLine(u.Message);
            }
        }

        #endregion
        
        private static string UsercPath
        {
            get
            {
                return string.Format("{0}\\Routines\\Mark II\\Settings\\MarkISVSettings_", Utilities.AssemblyDirectory);
            }
        }

        
        #region GUI Styling

        private void InitializeStyle()
        { 

            //Menu Toolstrip
            presetsToolStripMenuItem.ForeColor = Color.SeaGreen; //Text
            SaveToolStripMenuItem.ForeColor = Color.SeaGreen; //Text
            CloseToolStripMenuItem.ForeColor = Color.SeaGreen;//Text
            ThreadToolStripMenuItem.ForeColor = Color.SeaGreen;//Text
            ChangeLogToolStripMenuItem.ForeColor = Color.SeaGreen;//Text
            HelpToolStripMenuItem.ForeColor = Color.SeaGreen;//Text
            //menuStrip1.BackColor = Color.GhostWhite; //Background
            
            //Main Property Grid
            //pMain.HelpBackColor = Color.FromArgb(45, 45, 48); // Description
            pMain.HelpForeColor = Color.Black;// Description
            //pMain.BackColor = Color.FromArgb(45, 45, 48); // Category
            pMain.ForeColor = Color.SeaGreen; // Category
            //pMain.LineColor = Color.FromArgb(45, 45, 48); // Category
            pMain.CategoryForeColor = Color.SeaGreen;  //Text
            //pMain.ViewBackColor = Color.FromArgb(45, 45, 48); // properties
            pMain.ViewForeColor = Color.Black; // properties
            pMain.ToolbarVisible = false; // show toolbar
            pMain.CollapseAllGridItems(); //collapse all Category
            pMain.PerformAutoScale(); //Scale that shit
            
            //Pet Property Grid
            //pPet.HelpBackColor = Color.FromArgb(45, 45, 48); // Description
            pPet.HelpForeColor = Color.Black;// Description
            //pPet.BackColor = Color.FromArgb(45, 45, 48); // Category
            pPet.ForeColor = Color.SeaGreen; // Category
            //pPet.LineColor = Color.FromArgb(45, 45, 48); // Category
            pPet.CategoryForeColor = Color.SeaGreen;  //Text
            //pPet.ViewBackColor = Color.FromArgb(45, 45, 48); // properties
            pPet.ViewForeColor = Color.Black; // properties
            pPet.ToolbarVisible = false; // show toolbar
            //pPet.CollapseAllGridItems(); //collapse all Category
            pPet.PerformAutoScale();

            //Cooldown Property Grid
            //pPet.HelpBackColor = Color.FromArgb(45, 45, 48); // Description
            pCooldowns.HelpForeColor = Color.Black;// Description
            //pPet.BackColor = Color.FromArgb(45, 45, 48); // Category
            pCooldowns.ForeColor = Color.SeaGreen; // Category
            //pPet.LineColor = Color.FromArgb(45, 45, 48); // Category
            pCooldowns.CategoryForeColor = Color.SeaGreen;  //Text
            //pPet.ViewBackColor = Color.FromArgb(45, 45, 48); // properties
            pCooldowns.ViewForeColor = Color.Black; // properties
            pCooldowns.ToolbarVisible = false; // show toolbar
            //pPet.CollapseAllGridItems(); //collapse all Category
            pCooldowns.PerformAutoScale();

        }

        #endregion

        private void SaveSlot1Click_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Mark II has successfully saved your settings.", "Settings", MessageBoxButtons.OK, MessageBoxIcon.Information);
            Logger.InitLog(@"--------<-[Slot #1] Settings Saved->---------");
            MainSettings.Instance.SaveToFile(UsercPath + "Slot1.config");
        }

        private void LoadSlot1Click_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Mark II has successfully loaded your settings.", "Settings", MessageBoxButtons.OK, MessageBoxIcon.Information);
            Logger.InitLog(@"--------<-[Slot #1] Settings Loaded->---------");
            MainSettings.Instance.LoadFromXML(XElement.Load(UsercPath + "Slot1.config"));
        }

        private void SaveSlot2Click_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Mark II has successfully saved your settings.", "Settings", MessageBoxButtons.OK, MessageBoxIcon.Information);
            Logger.InitLog(@"--------<-[Slot #2] Settings Saved->---------");
            MainSettings.Instance.SaveToFile(UsercPath + "Slot2.config");
        }

        private void LoadSlot2Click_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Mark II has successfully loaded your settings.", "Settings", MessageBoxButtons.OK, MessageBoxIcon.Information);
            Logger.InitLog(@"--------<-[Slot #2] Settings Loaded->---------");
            MainSettings.Instance.LoadFromXML(XElement.Load(UsercPath + "Slot2.config"));
        }

        private void SaveSlot3Click_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Mark II has successfully saved your settings.", "Settings", MessageBoxButtons.OK, MessageBoxIcon.Information);
            Logger.InitLog(@"--------<-[Slot #3] Settings Saved->---------");
            MainSettings.Instance.SaveToFile(UsercPath + "Slot3.config");
        }

        private void LoadSlot3Click_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Mark II has successfully loaded your settings.", "Settings", MessageBoxButtons.OK, MessageBoxIcon.Information);
            Logger.InitLog(@"--------<-[Slot #3] Settings Loaded->---------");
            MainSettings.Instance.LoadFromXML(XElement.Load(UsercPath + "Slot3.config"));
        }
    }
}
