﻿// MarkI
// Created on 07/03/2013 at 4:03 PMh
// Extensions.cs created by <Mirabis>

using System.Runtime.InteropServices;
using System.Windows.Forms;
using Styx.Common;

namespace MarkII.GUI
{
    public class Extensions
    {

        /// <summary>
        ///     Combobox item
        /// </summary>
        public class CboItem
        {
            public readonly int E;
            private readonly string _s;

            public CboItem(int pe, string ps)
            {
                E = pe;
                _s = ps;
            }

            public override string ToString()
            {
                return _s;
            }

            /// <summary>
            ///     Sets Combo box to usable enum
            /// </summary>
            /// <param name="cb"></param>
            /// <param name="e"></param>
            public static void SetComboBoxEnum(ComboBox cb, int e)
            {
                CboItem item;
                for (int i = 0; i < cb.Items.Count; i++)
                {
                    item = (CboItem)cb.Items[i];
                    if (item.E != e) continue;
                    cb.SelectedIndex = i;
                    return;
                }
                item = (CboItem)cb.Items[0];
                Logging.Write("Dialog Error: combobox {0} does not have enum({1}) in list, defaulting to enum({2})",
                              cb.Name, e, item.E);
                cb.SelectedIndex = 0;
            }


            /// <summary>
            ///     Gets the enumerator
            /// </summary>
            /// <param name="cb"></param>
            /// <returns></returns>
            public static int GetComboBoxEnum(ComboBox cb)
            {
                var item = (CboItem)cb.Items[cb.SelectedIndex];
                return item.E;
            }
        }
        public class SelectiveHealName
        {
            // ReSharper disable InconsistentNaming
            public SelectiveHealName(string _ListItem)
            // ReSharper restore InconsistentNaming
            {
                ListItem = _ListItem;
            }

            public string ListItem { get; set; }
        }

        public class SelectiveHealGUID
        {
            // ReSharper disable InconsistentNaming
            public SelectiveHealGUID(ulong _ListItem)
            // ReSharper restore InconsistentNaming
            {
                ListItem = _ListItem;
            }

            public ulong ListItem { get; set; }
        }

        #region KeyBoardPolling

        [DllImport("user32.dll")]
        private static extern short GetAsyncKeyState(Keys vKey);

        public static bool IsKeyDown(Keys key)
        {
            return (GetAsyncKeyState(key)) != 0;
        }

        #endregion
    }


   
}