﻿#region Author Information

// // Mark II - Auras.cs
// // Created on 16/04/2013 at 13:37 Uhr
// // Author: Mirabis - Moreno Sint Hill
// 

#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using MarkII.Managers;
using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace MarkII.Misc
{
    public static class Auras
    {
        /*
        /// <summary>
        ///     Indicates if the selected unit has our debuff or not.
        /// </summary>
        /// <param name="onUnit">The specified unit</param>
        /// <param name="auraId">The debuff id to check for</param>
        /// <returns>Returns true, if the the checked aura is present</returns>
        public static bool HasAura(this WoWUnit onUnit, int auraId)
        {
            if (onUnit == null) return false;
            WoWAura aura = onUnit.GetAllAuras().FirstOrDefault(u => u.SpellId == auraId);
            return aura != null;
        }

        /// <summary>
        ///     Indicates if the selected unit has our debuff or not.
        /// </summary>
        /// <param name="onUnit">The specified unit</param>
        /// <param name="auraId">The debuff id to check for</param>
        /// <param name="set"></param>
        /// <returns>Returns true, if the the checked aura is present</returns>
        public static bool HasAura(this WoWUnit onUnit, int auraId, HashSet<WoWAura> set)
        {
            if (onUnit == null) return false;
            WoWAura aura = set.FirstOrDefault(u => u.SpellId == auraId);
            return aura != null;
        }

        /// <summary>
        ///     Indicates if the selected unit has our debuff or not.
        /// </summary>
        /// <param name="onUnit">The specified unit</param>
        /// <param name="auraId">The debuff id to check for</param>
        /// <param name="auraTimeLeft">The tim left of the checked aura in milliseconds</param>
        /// <returns>Returns true, if the the checked aura is present and is higher or equal to the time left</returns>
        public static bool HasAura(this WoWUnit onUnit, int auraId, double auraTimeLeft)
        {
            if (onUnit == null) return false;
            WoWAura aura = onUnit.GetAllAuras().FirstOrDefault(u => u.SpellId == auraId);
            return aura != null && aura.TimeLeft >= TimeSpan.FromMilliseconds(auraTimeLeft);
        }

        /// <summary>
        ///     Indicates if the selected unit has our debuff or not.
        /// </summary>
        /// <param name="onUnit">The specified unit</param>
        /// <param name="auraId">The debuff id to check for</param>
        /// <param name="stackcount"> The stack count</param>
        /// <param name="auraTimeLeft">The tim left of the checked aura in milliseconds</param>
        /// <returns>Returns true, if the the checked aura is present and is higher or equal to the time left</returns>
        public static bool HasAura(this WoWUnit onUnit, int auraId, int stackcount, double auraTimeLeft)
        {
            if (onUnit == null) return false;
            WoWAura aura = onUnit.GetAllAuras().FirstOrDefault(u => u.SpellId == auraId);
            return aura != null && aura.StackCount >= stackcount &&
                   aura.TimeLeft >= TimeSpan.FromMilliseconds(auraTimeLeft);
        }

        /// <summary>
        ///     Indicates if the selected unit has our debuff or not.
        /// </summary>
        /// <param name="onUnit">The specified unit</param>
        /// <param name="auraId">The debuff id to check for</param>
        /// <returns>Returns true, if the the checked aura is present</returns>
        public static bool HasMyAura(this WoWUnit onUnit, int auraId)
        {
            if (onUnit == null) return false;
            WoWAura aura =
                onUnit.GetAllAuras().FirstOrDefault(u => u.CreatorGuid == StyxWoW.Me.Guid && u.SpellId == auraId);
            return aura != null;
        }

        /// <summary>
        ///     Indicates if the selected unit has our debuff or not.
        /// </summary>
        /// <param name="onUnit">The specified unit</param>
        /// <param name="auraId">The debuff id to check for</param>
        /// <param name="auraTimeLeft">The tim left of the checked aura in milliseconds</param>
        /// <returns>Returns true, if the the checked aura is present and is higher or equal to the time left</returns>
        public static bool HasMyAura(this WoWUnit onUnit, int auraId, double auraTimeLeft)
        {
            if (onUnit == null) return false;
            WoWAura aura =
                onUnit.GetAllAuras().FirstOrDefault(u => u.CreatorGuid == StyxWoW.Me.Guid && u.SpellId == auraId);
            return aura != null && aura.TimeLeft >= TimeSpan.FromMilliseconds(auraTimeLeft);
        }

        /// <summary>
        ///     Indicates if the selected unit has our debuff or not.
        /// </summary>
        /// <param name="onUnit">The specified unit</param>
        /// <param name="auraId">The debuff id to check for</param>
        /// <param name="stackcount"> The stack count</param>
        /// <returns>Returns true, if the the checked aura is present and the stacks match or are higher</returns>
        public static bool HasMyAura(this WoWUnit onUnit, int auraId, int stackcount)
        {
            if (onUnit == null) return false;
            WoWAura aura =
                onUnit.GetAllAuras().FirstOrDefault(u => u.CreatorGuid == StyxWoW.Me.Guid && u.SpellId == auraId);
            return aura != null && aura.StackCount >= stackcount;
        }

        /// <summary>
        ///     Indicates if the selected unit has our debuff or not.
        /// </summary>
        /// <param name="onUnit">The specified unit</param>
        /// <param name="auraId">The debuff id to check for</param>
        /// <param name="stackcount"> The stack count</param>
        /// <param name="auraTimeLeft">The tim left of the checked aura in milliseconds</param>
        /// <returns>Returns true, if the the checked aura is present and is higher or equal to the time left</returns>
        public static bool HasMyAura(this WoWUnit onUnit, int auraId, int stackcount, double auraTimeLeft)
        {
            if (onUnit == null) return false;
            WoWAura aura =
                onUnit.GetAllAuras().FirstOrDefault(u => u.CreatorGuid == StyxWoW.Me.Guid && u.SpellId == auraId);
            return aura != null && aura.StackCount >= stackcount &&
                   aura.TimeLeft >= TimeSpan.FromMilliseconds(auraTimeLeft);
        }

        /// <summary>
        ///     Indicates if the selected unit has ANY buff.
        /// </summary>
        /// <param name="onUnit">The specified unit</param>
        /// <param name="auraIds">The buff ids to check for</param>
        /// <returns></returns>
        public static bool HasAnyAura(this WoWUnit onUnit, params int[] auraIds)
        {
            if (onUnit == null) return false;
            WoWAuraCollection auras = onUnit.GetAllAuras();
            var hashes = new HashSet<int>(auraIds);
            return auras.Any(a => hashes.Contains(a.SpellId));
        }

        /// <summary>
        /// </summary>
        /// <param name="unit"></param>
        /// <param name="auraIDs"></param>
        /// <returns></returns>
        public static bool HasAnyAura(this WoWUnit unit, HashSet<int> auraIDs)
        {
            WoWAuraCollection auras = unit.GetAllAuras();
            return auras.Any(a => auraIDs.Contains(a.SpellId));
        }
         */

        #region Special Aura Handlers

        private static IEnumerable<SpellEffect> GetSpellEffects(this WoWSpell spell)
        {
            var effects = new SpellEffect[3];
            effects[0] = spell.GetSpellEffect(0);
            effects[1] = spell.GetSpellEffect(1);
            effects[2] = spell.GetSpellEffect(2);
            return effects;
        }

        #endregion

        //New Cached Auras }} Credit to Wulf # PureRotation

        public static bool HasCachedAura(this WoWUnit unit, int aura, int stacks = 0, double msLeft = 0,
                                         int expiry = 500)
        {
            WoWAura cachedResult = unit.GetAllCachedAuras(expiry).FirstOrDefault(a => a.SpellId == aura);

            if (cachedResult == null)
                return false;

            // debugging put your spell in here 
            //if (cachedResult.Name == "Unstable Affliction")
            //Logger.InfoLog("[TimeLeft] {0} : {1} msLeft {2} msSetpoint {3}", aura, unit, cachedResult.TimeLeft.TotalMilliseconds, msLeft);

            if (cachedResult.TimeLeft.TotalMilliseconds > msLeft)
                return cachedResult.StackCount >= stacks;

            return false;
        }

        public static bool HasCachedAura(this WoWUnit unit, string aura, int stacks = 0, double msLeft = 0,
                                         int expiry = 500)
        {
            WoWAura cachedResult = unit.GetAllCachedAuras(expiry).FirstOrDefault(a => a.Spell.Name == aura);

            if (cachedResult == null)
                return false;

            // debugging put your spell in here 
            //if (cachedResult.Name == "Unstable Affliction")
            //Logger.InfoLog("[TimeLeft] {0} : {1} msLeft {2} msSetpoint {3}", aura, unit, cachedResult.TimeLeft.TotalMilliseconds, msLeft);

            if (cachedResult.TimeLeft.TotalMilliseconds > msLeft)
                return cachedResult.StackCount >= stacks;

            return false;
        }

        public static bool HasMyCachedAura(this WoWUnit unit, string aura, int stacks = 0, double msLeft = 0,
                                           int expiry = 500)
        {
            WoWAura cachedResult =
                unit.GetAllCachedAuras(expiry)
                    .FirstOrDefault(a => a.Spell.Name == aura && a.CreatorGuid == StyxWoW.Me.Guid);

            if (cachedResult == null)
                return false;

            // debugging put your spell in here 
            //if (cachedResult.Name == "Unstable Affliction")
            //Logger.InfoLog("[TimeLeft] {0} : {1} msLeft {2} msSetpoint {3}", aura, unit, cachedResult.TimeLeft.TotalMilliseconds, msLeft);

            if (cachedResult.TimeLeft.TotalMilliseconds > msLeft)
                return cachedResult.StackCount >= stacks;

            return false;
        }

        public static bool HasAnyCachedAura(this WoWUnit unit, string[] auranames, int expiry = 500)
        {
            WoWAuraCollection cachedauras = unit.GetAllCachedAuras(expiry);
            var hashes = new HashSet<string>(auranames);
            return cachedauras.Any(a => hashes.Contains(a.Spell.Name));
        }

        public static bool HasAnyCachedAura(this WoWUnit unit, HashSet<int> auraids, int expiry = 500)
        {
            WoWAuraCollection cachedauras = unit.GetAllCachedAuras(expiry);
            return cachedauras.Any(a => auraids.Contains(a.SpellId));
        }

        public static uint CachedStackCount(this WoWUnit unit, int aura, bool fromMyAura = false, int expiry = 500)
        {
            {
                if (unit != null)
                {
                    WoWAura cachedResult =
                        unit.GetAllCachedAuras(expiry)
                            .FirstOrDefault(a => a.SpellId == aura && (!fromMyAura || a.CreatorGuid == StyxWoW.Me.Guid));
                    if (cachedResult != null) return cachedResult.StackCount;
                }
                return 0;
            }
        }

        public static uint CachedStackCount(this WoWUnit unit, string aura, bool fromMyAura = false, int expiry = 500)
        {
            {
                if (unit != null)
                {
                    WoWAura cachedResult =
                        unit.GetAllCachedAuras(expiry)
                            .FirstOrDefault(
                                a => a.Spell.Name == aura && (!fromMyAura || a.CreatorGuid == StyxWoW.Me.Guid));
                    if (cachedResult != null) return cachedResult.StackCount;
                }
                return 0;
            }
        }

        public static bool HasCachedAuraWithEffect(this WoWUnit unit, WoWApplyAuraType auraType, int miscValue,
                                                   int basePointsMin, int basePointsMax)
        {
            WoWAuraCollection auras = unit.GetAllCachedAuras();
            return (from a in auras
                    where a.Spell != null
                    let spell = a.Spell
                    from e in spell.GetSpellEffects()
                    // First check: Ensure the effect is... well... valid
                    where e != null &&
                          // Ensure the aura type is correct.
                          e.AuraType == auraType &&
                          // Check for a misc value. (Resistance types, etc)
                          (miscValue == -1 || e.MiscValueA == miscValue) &&
                          // Check for the base points value. (Usually %s for most debuffs)
                          e.BasePoints >= basePointsMin && e.BasePoints <= basePointsMax
                    select a).Any();
        }

        public static bool HasCachedAuraWithMechanic(this WoWUnit unit, params WoWSpellMechanic[] mechanics)
        {
            WoWAuraCollection auras = unit.GetAllCachedAuras();
            return auras.Any(a => mechanics.Contains(a.Spell.Mechanic));
        }

        public static bool HasCachedAuraWithEffect(this WoWUnit unit, WoWApplyAuraType applyType)
        {
            return
                unit.GetAllCachedAuras()
                    .Any(a => a.Spell != null && a.Spell.SpellEffects.Any(se => applyType == se.AuraType));
        }

        public static bool HasCachedAuraWithEffect(this WoWUnit unit, params WoWApplyAuraType[] applyType)
        {
            var hashes = new HashSet<WoWApplyAuraType>(applyType);
            return
                unit.GetAllCachedAuras().Any(
                    a => a.Spell != null && a.Spell.SpellEffects.Any(se => hashes.Contains(se.AuraType)));
        }

        public static TimeSpan HasCachedAuraTimeLeft(this WoWUnit onUnit, int auraID, bool fromMyAura)
        {
            WoWAura wantedAura = onUnit.GetAllCachedAuras()
                                       .FirstOrDefault(
                                           a =>
                                           a.SpellId == auraID && a.TimeLeft > TimeSpan.Zero &&
                                           (!fromMyAura || a.CreatorGuid == StyxWoW.Me.Guid));

            return wantedAura != null ? wantedAura.TimeLeft : TimeSpan.Zero;
        }

        public static TimeSpan HasCachedAuraTimeLeft(this WoWUnit onUnit, string auraname, bool fromMyAura)
        {
            WoWAura wantedAura = onUnit.GetAllCachedAuras()
                                       .FirstOrDefault(
                                           a =>
                                           a.Spell.Name == auraname && a.TimeLeft > TimeSpan.Zero &&
                                           (!fromMyAura || a.CreatorGuid == StyxWoW.Me.Guid));

            return wantedAura != null ? wantedAura.TimeLeft : TimeSpan.Zero;
        }

        internal static WoWAuraCollection GetAllCachedAuras(this WoWUnit unit, int expiry = 500)
        {
            string cacheKey = "GetAllAuras_" + unit.Guid;

            // Check the cache
            var getAllAuras = CacheManager.Get<WoWAuraCollection>(cacheKey);

            if (getAllAuras == null)
            {
                // Go and retrieve the data from the objectManager
                getAllAuras = unit.GetAllAuras();

                // Then add it to the cache so we 
                // can retrieve it from there next time
                // set the object to expire
                CacheManager.Add(getAllAuras, cacheKey, expiry);
                Logger.DebugLog("[Re-Build] cachedObject({0}) at : {1}", cacheKey, DateTime.Now);
            }
            else
            {
                //Logger.DebugLog("[Cache] cachedObject({0}) at : {1}", cacheKey, DateTime.Now);
            }
            return getAllAuras;
        }
    }
}