using System.Collections.Generic;
using System.Linq;
using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace MarkII.Misc
{
    internal class Lists
    {
        
        #region Interrupting

        #region Casting Spells

        public static readonly HashSet<int> InteruptableSpells = new HashSet<int>
            {
        #region Raids
                    117833, // Crazy Thought - Meng the Demented
                    122193, // Mending - Wind lord Mel'jarah
                    124077, // Dispatch - Grand Empress Shek
                    117187, // Lighting bolt - Protectors of the Endless
                    117163, // Water Bolt -  Elder Asani
        #endregion

        #region Dungeon
                    115289, // Spirit Gale - Scarlet Monastery
                    113134, // Mass Ressurection - Scarlet Monastery
                    12039, // Heal - Scarlet Monastery
                    118903, // Hex of Lethargy - Mogushan palace
                    118958, // Iron Protector - Mogushan Palace
                    107357, // Rising Hate - Shado-Pan Monastery
                    
        #endregion

        #region Player
                    30451, // Arcane Blast, //
                    32546, // Binding Heal, //
                    1064, // Chain Heal, //
                    421, // Chain Lightning, //
                    50796, // Chaos Bolt, //
                    693, // Create Healthstone, //
                    6201, // Create Healthstone, //
                    33786, // Cyclone, //
                    82326, // Divine Light, //
                    61882, // Earthquake, //
                    20066, // Repentance, //
                    339, // Entangling Roots, //
                    12051, // Evocation, //
                    879, // Exorcism, //
                    5782, // Fear, //
                    133, // Fireball, //
                    2120, // Flamestrike, //
                    2061, // Flash Heal, //
                    19750, // Flash of Light, //
                    116, // Frostbolt, //
                    44614, // Frostfire Bolt, //
                    2060, // Greater Heal, //
                    77472, // Greater Healing Wave, //
                    71521, // Hand of Gul'dan, //
                    48181, // Haunt, //
                    2050, // Heal, //
                    73920, // Healing Rain, //
                    8004, // Healing Surge, //
                    5185, // Healing Touch, //
                    331, // Healing Wave, //
                    51514, // Hex, //
                    2637, // Hibernate, //
                    14914, // Holy Fire, //
                    635, // Holy Light, //
                    82327, // Holy Radiance, //
                    5484, // Howl of Terror, //
                    49203, // Hungering Cold, //
                    348, // Immolate, //
                    29722, // Incinerate, //
                    51505, // Lava Burst, //
                    403, // Lightning Bolt, //
                    8129, // Mana Burn, //
                    32375, // Mass Dispel, //
                    8092, // Mind Blast, //
                    605, // Mind Control, //
                    73510, // Mind Spike, //
                    50464, // Nourish, //
                    118, // Polymorph, //
                    28272, // Polymorph, //
                    61721, // Polymorph, //
                    61305, // Polymorph, //
                    61780, // Polymorph, //
                    28271, // Polymorph, //
                    596, // Prayer of Healing, //
                    11366, // Pyroblast, //
                    20484, // Rebirth, //
                    8936, // Regrowth, //
                    1513, // Scare Beast, //
                    2948, // Scorch, //
                    5676, // Searing Pain, //
                    27243, // Seed of Corruption, //
                    9484, // Shackle Undead, //
                    686, // Shadow Bolt, //
                    585, // Smite, //
                    6353, // Soul Fire, //
                    2912, // Starfire, //
                    78674, // Starsurge, //
                    30146, // Summon Felguard, //
                    691, // Summon Felhunter, //
                    688, // Summon Imp, //
                    1122, // Summon Infernal, //
                    712, // Summon Succubus, //
                    697, // Summon Voidwalker, //
                    30108, // Unstable Affliction, //
                    34914, // Vampiric Touch, //
                    5176, // Wrath, //
        #endregion
        };

        #endregion

        #region Channeled Spells

        public static readonly HashSet<int> ChanneledInteruptableSpells = new HashSet<int>
            {
            5143, // Arcane Missiles, //
            42650, // Army of the Dead, //
            10, // Blizzard, //
            64843, // Divine Hymn, //
            689, // Drain Life, //
            89420, // Drain Life, //
            1120, // Drain Soul, //
            755, // Health Funnel, //
            1949, // Hellfire, //
            85403, // Hellfire, //
            16914, // Hurricane, //
            64901, // Hymn of Hope, //
            50589, // Immolation Aura, //
            15407, // Mind Flay, //
            47540, // Penance, //
            5740, // Rain of Fire, //
            740, // Tranquility, //
            103103, // Malefic Grasp //
        };

        #endregion

        public static double InterruptCastNoChannel(WoWUnit target)
        {
            double timeLeft = 0;

            if (target != null && !target.HasAura(31821) && target.IsCasting && InteruptableSpells.Contains(target.CastingSpellId))
            {
                timeLeft = target.CurrentCastTimeLeft.TotalMilliseconds;
            }
            return timeLeft;
        }

        public static double InterruptCastChannel(WoWUnit target)
        {
            double timeLeft = 0;

            if (target != null && target.IsChanneling && !target.HasAura(31821) &&
                ChanneledInteruptableSpells.Contains(target.CastingSpellId))
            {
                timeLeft = target.CurrentChannelTimeLeft.TotalMilliseconds;
            }
            return timeLeft;
        }
        #endregion

        #region Reflecting Cast Spells

        public static readonly HashSet<int> ReflectableSpells = new HashSet<int>
            {
            20066, // Repentance
            50796, // Chaos Bolt, //
            51505, // Lava Burst, //
            33786, // Cyclone, //
            113506, // Symbiosis Cyclone
         // 339, // Entangling Roots, //
            5782, // Fear, //
            51514, // Hex, //
            118, // Polymorph, //
            28272, // Polymorph, //
            61721, // Polymorph, //
            61305, // Polymorph, //
            61780, // Polymorph, //
            28271, // Polymorph, //
        };

        public static double ReflectCast(WoWUnit target)
        {
            double timeLeft = 0;

            if (target != null && target.IsCasting && ReflectableSpells.Contains(target.CastingSpellId))
            {
                timeLeft = target.CurrentCastTimeLeft.TotalMilliseconds;
            }
            return timeLeft;
        }

        #endregion

        #region Crowd Controls

        public static readonly HashSet<int> CcList = new HashSet<int>
            {
	        108194, // "CC",		-- Asphyxiate
	        115001, // "CC",		-- Remorseless Winter
	        91800,  // "CC",		-- Gnaw
	        91797,  // "CC",		-- Monstrous Blow (Dark Transformation)
	        113801, // "CC",		-- Bash (Force of Nature - Feral Treants)
	        102795, // "CC",		-- Bear Hug
	        33786,  // "CC",		-- Cyclone
	        99,     // "CC",		-- Disorienting Roar
	        2637,   // "CC",		-- Hibernate
	        22570,  // "CC",		-- Maim
	        5211,   // "CC",		-- Mighty Bash
	        9005,   // "CC",		-- Pounce
	        102546, // "CC",		-- Pounce (Incarnation)
	        110698, // "CC",		-- Hammer of Justice (Paladin)
	        113004, // "CC",		-- Intimidating Roar Fleeing in fear, (Warrior)
	        113056, // "CC",		-- Intimidating Roar Cowering in fear, (Warrior)
	        117526, // "CC",		-- Binding Shot
	        3355,   // "CC",		-- Freezing Trap
	        1513,   // "CC",		-- Scare Beast
	        19503,  // "CC",		-- Scatter Shot
	        19386,  // "CC",		-- Wyvern Sting
	        90337,  // "CC",		-- Bad Manner (Monkey)
	        24394,  // "CC",		-- Intimidation
	        126246, // "CC",		-- Lullaby (Crane)
	        126355, // "CC",		-- Paralyzing Quill (Porcupine)
	        126423, // "CC",		-- Petrifying Gaze (Basilisk)
	        50519,  // "CC",		-- Sonic Blast (Bat)
	        56626,  // "CC",		-- Sting (Wasp)
	        118271, // "CC",		-- Combustion Impact
	        44572,  // "CC",		-- Deep Freeze
	        31661,  // "CC",		-- Dragon's Breath
	        118,    // "CC",		-- Polymorph
	        61305,  // "CC",		-- Polymorph: Black Cat
	        28272,  // "CC",		-- Polymorph: Pig
	        61721,  // "CC",		-- Polymorph: Rabbit
	        61780,  // "CC",		-- Polymorph: Turkey
	        28271,  // "CC",		-- Polymorph: Turtle
	        82691,  // "CC",		-- Ring of Frost
	        123393, // "CC",		-- Breath of Fire (Glyph of Breath of Fire)
	        126451, // "CC",		-- Clash
	        122242, // "CC",		-- Clash (not sure which one is right)
	        119392, // "CC",		-- Charging Ox Wave
	        117418, // "CC",		-- Fists of Fury
	        119381, // "CC",		-- Leg Sweep
	        115078, // "CC",		-- Paralysis
	        105421, // "CC",		-- Blinding Light
	        115752, // "CC",		-- Blinding Light (Glyph of Blinding Light)
	        105593, // "CC",		-- Fist of Justice
	        853,    // "CC",		-- Hammer of Justice
	        119072, // "CC",		-- Holy Wrath
	        20066,  // "CC",		-- Repentance
	        10326,  // "CC",		-- Turn Evil
	        113506, // "CC",		-- Cyclone (Symbiosis)
	        605,    // "CC",		-- Dominate Mind
	        88625,  // "CC",		-- Holy Word: Chastise
	        64044,  // "CC",		-- Psychic Horror
	        8122,   // "CC",		-- Psychic Scream
	        113792, // "CC",		-- Psychic Terror (Psyfiend)
	        9484,   // "CC",		-- Shackle Undead
	        87204,  // "CC",		-- Sin and Punishment
	        2094,   // "CC",		-- Blind
	        1833,   // "CC",		-- Cheap Shot
	        1776,   // "CC",		-- Gouge
	        408,    // "CC",		-- Kidney Shot
	        113953, // "CC",		-- Paralysis (Paralytic Poison)
	        6770,   // "CC",		-- Sap
	        76780,  // "CC",		-- Bind Elemental
	        77505,  // "CC",		-- Earthquake
	        51514,  // "CC",		-- Hex
	        118905, // "CC",		-- Static Charge (Capacitor Totem)
	        118345, // "CC",		-- Pulverize
	        710,    // "CC",		-- Banish
	        54786,  // "CC",		-- Demonic Leap (Metamorphosis)
	        5782,   // "CC",		-- Fear
	        118699, // "CC",		-- Fear
	        130616, // "CC",		-- Fear (Glyph of Fear)
	        5484,   // "CC",		-- Howl of Terror
	        22703,  // "CC",		-- Infernal Awakening
	        6789,   // "CC",		-- Mortal Coil
	        132412, // "CC",		-- Seduction (Grimoire of Sacrifice)
	        30283,  // "CC",		-- Shadowfury
	        104045, // "CC",		-- Sleep (Metamorphosis)
	        89766,  // "CC",		-- Axe Toss (Felguard/Wrathguard)
	        115268, // "CC",		-- Mesmerize (Shivarra)
	        6358,   // "CC",		-- Seduction (Succubus)
	        7922,   // "CC",		-- Charge Stun
	        118895, // "CC",		-- Dragon Roar
	        5246,   // "CC",		-- Intimidating Shout (aoe)
	        20511,  // "CC",		-- Intimidating Shout (targeted)
	        132168, // "CC",		-- Shockwave
	        107570, // "CC",		-- Storm Bolt
	        105771, // "CC",		-- Warbringer
	        30217,  // "CC",		-- Adamantite Grenade
	        67769,  // "CC",		-- Cobalt Frag Bomb
	        30216,  // "CC",		-- Fel Iron Bomb
	        107079, // "CC",		-- Quaking Palm
	        13327,  // "CC",		-- Reckless Charge
	        20549,  // "CC",		-- War Stomp
        };


        public static double CCd(WoWUnit u)
        {
            if (u == null || !u.IsValid || !u.IsAlive)
            {
                return 0;
            }

            WoWAuraCollection auras = u.GetAllCachedAuras();
            WoWAura longestDebuff = auras.Where(a => CcList.Contains(a.SpellId)).OrderBy(a => a.TimeLeft).FirstOrDefault();

            if (longestDebuff == null)
            {
                return 0;
            }
            return longestDebuff.TimeLeft.TotalMilliseconds;

        }

        #endregion

        #region Dots

        public static readonly HashSet<int> DotList = new HashSet<int>
            {
            3674, // Black Arrow
            55078, // Blood Plague
            31803, // Censure
            83853, // Combustion
            2818, // Deadly Poison
            43265, // Deathh and Decay
            2944, // Devouring Plague
            603, // Doom
            53301, // Explosive Shot
            8050, // Flame Shock
            2120, //Flame Strike
            113092, //Frost Bomb
            55095, //Frost Fever
            14914, // Holy Fire
            44457, //Living Bomb
            103103, // Malefic Grasp
            8921, //Moonfire
            114923, //Nether Tempest
            11366, // Pyroblast
            118253, //Serpent Sting
            589, //Shadow Word Pain
            93402, //Sunfire
            31117, //Unstable affliction
            91075, 91076 //Vengeful Wisp

        };

        public static double Dotted(WoWUnit u)
        {
            if (u == null || !u.IsValid || !u.IsAlive)
                return 0;

            WoWAuraCollection auras = u.GetAllCachedAuras();
            WoWAura longestDebuff = auras.Where(a => DotList.Contains(a.SpellId)).OrderBy(a => a.TimeLeft).FirstOrDefault();

            if (longestDebuff == null)
            {
                return 0;
            }
            // MAD.StandardLog("DebuffRootCanCleanse: " + longestDebuff.Name + " - " + longestDebuff.SpellId);
            return longestDebuff.TimeLeft.TotalMilliseconds;

        }

        #endregion

        #region Immune

        public static readonly HashSet<int> ImmuneList = new HashSet<int>
            {
            115018, // "Immune",		-- Desecrated Ground
            110617, // "Immune",		-- Deterrence (Hunter)
            110715, // "Immune",		-- Dispersion (Priest)
            110700, // "Immune",		-- Divine Shield (Paladin)
            110696, // "Immune",		-- Ice Block (Mage)
            19263,  // "Immune",		-- Deterrence
            45438,  // "Immune",		-- Ice Block
            642,    // "Immune",		-- Divine Shield (paladin)
            47585,  // "Immune",		-- Dispersion
            1022, 	// "Physical Immune" -- Hand of Protection (Paladin)
            126423, // "CC",	    	-- Petrifying Gaze (Basilisk)
         //	46924,  // "Immune CC",		-- Bladestorm Only immune to CC's
        };

        public static double Immune(WoWUnit u)
        {
            if (u == null || !u.IsValid || !u.IsAlive)
                return 0;

            WoWAura longestDebuff = u.Auras.Values.Where(a => ImmuneList.Contains(a.SpellId)).OrderBy(a => a.TimeLeft).FirstOrDefault();

            if (longestDebuff == null)
            {
                return 0;
            }

            // MAD.StandardLog("DebuffRootCanCleanse: " + longestDebuff.Name + " - " + longestDebuff.SpellId);
            return longestDebuff.TimeLeft.TotalMilliseconds;

        }

        #endregion

        #region ImmuneSpell

        public static readonly HashSet<int> ImmuneSpellList = new HashSet<int>
            {
            48707, // Anti-Magic Shell
            110570, // Anti-Magic Shell (Death Knight)
            110788, // Cloak of Shadows (Rogue)
            113002, // Spell Reflection (Warrior)
            115760, // Glyph of Ice Block
            131523, // Zen Meditation
            114239, // Phantasm
            31224, // Cloak of Shadows
            8178, // Grounding Totem Effect (Grounding Totem)
            23920, // Spell Reflection
            114028, // Mass Spell Reflection
        };

        public static double ImmuneSpell(WoWUnit u)
        {
            if (u == null || !u.IsValid || !u.IsAlive)
                return 0;

            WoWAura longestDebuff = u.Auras.Values.Where(a => ImmuneSpellList.Contains(a.SpellId)).OrderBy(a => a.TimeLeft).FirstOrDefault();

            if (longestDebuff == null)
            {
                return 0;
            }

            // MAD.StandardLog("DebuffRootCanCleanse: " + longestDebuff.Name + " - " + longestDebuff.SpellId);
            return longestDebuff.TimeLeft.TotalMilliseconds;

        }



        #endregion

        #region Slow effects

        public static readonly HashSet<int> SlowList = new HashSet<int>
            {
	        45524,  // "Snare",		-- Chains of Ice
	        50435,  // "Snare",		-- Chilblains
	       // --43265,  // "Snare",		-- Death and Decay (Glyph of Death and Decay) - no way to distinguish between glyphed spell and normal. :(
	        115000, // "Snare",		-- Remorseless Winter
	        50259,  // "Snare",		-- Dazed (Wild Charge - Cat)
	        58180,  // "Snare",		-- Infected Wounds
	        61391,  // "Snare",		-- Typhoon
	        127797, // "Snare",		-- Ursol's Vortex
	      //  --???, // "Snare",		-- Wild Mushroom: Detonate
	     //   --110610, // "Snare",		-- Ice Trap (Hunter)
	        35101,  // "Snare",		-- Concussive Barrage
	        5116,   // "Snare",		-- Concussive Shot
	        61394,  // "Snare",		-- Frozen Wake (Glyph of Freezing Trap)
	        13810,  // "Snare",		-- Ice Trap
	        50433,  // "Snare",		-- Ankle Crack (Crocolisk)
	        54644,  // "Snare",		-- Frost Breath (Chimaera)
	        //--11113,  // "Snare",		-- Blast Wave - gone?
	        121288, // "Snare",		-- Chilled (Frost Armor)
	        120,    // "Snare",		-- Cone of Cold
	        116,    // "Snare",		-- Frostbolt
	        44614,  // "Snare",		-- Frostfire Bolt
	        113092, // "Snare",		-- Frost Bomb
	        31589,  // "Snare",		-- Slow
	        116095, // "Snare",		-- Disable
	        118585, // "Snare",		-- Leer of the Ox
	        123727, // "Snare",		-- Dizzying Haze
	        123586, // "Snare",		-- Flying Serpent Kick
	        110300, // "Snare",		-- Burden of Guilt
	        63529,  // "Snare",		-- Dazed - Avenger's Shield
	        20170,  // "Snare",		-- Seal of Justice
	        15407,  // "Snare",		-- Mind Flay
	        3409,   // "Snare",		-- Crippling Poison
	        26679,  // "Snare",		-- Deadly Throw
	        119696, // "Snare",		-- Debilitation
	        3600,   // "Snare",		-- Earthbind (Earthbind Totem)
	        77478,  // "Snare",		-- Earthquake (Glyph of Unstable Earth)
	        8034,   // "Snare",		-- Frostbrand Attack
	        8056,   // "Snare",		-- Frost Shock
	        51490,  // "Snare",		-- Thunderstorm
	        18223,  // "Snare",		-- Curse of Exhaustion
	        47960,  // "Snare",		-- Shadowflame
	        1715,   // "Snare",		-- Hamstring
	        12323,  // "Snare",		-- Piercing Howl
	        129923, // "Snare",		-- Sluggish (Glyph of Hindering Strikes)
	        137637, // "Snare",		-- Warbringer
	        1604,   // "Snare",		-- Dazed
        };

        public static double Snared(WoWUnit u)
        {
            if (u == null || !u.IsValid || !u.IsAlive)
                return 0;

            WoWAuraCollection auras = u.GetAllCachedAuras();
            WoWAura longestDebuff = auras.Where(a => SlowList.Contains(a.SpellId)).OrderBy(a => a.TimeLeft).FirstOrDefault();

            if (longestDebuff == null)
            {
                return 0;
            }

            // MAD.StandardLog("DebuffRootCanCleanse: " + longestDebuff.Name + " - " + longestDebuff.SpellId);
            return longestDebuff.TimeLeft.TotalMilliseconds;

        }

        #endregion

        #region Root effects

        public static readonly HashSet<int> RootList = new HashSet<int>
            {
	        96294,  // "Root",		-- Chains of Ice (Chilblains)
	        91807,  // "Root",		-- Shambling Rush (Dark Transformation)
	        339,    // "Root",		-- Entangling Roots
	        113770, // "Root",		-- Entangling Roots (Force of Nature - Balance Treants)
	        19975,  // "Root",		-- Entangling Roots (Nature's Grasp)
	        45334,  // "Root",		-- Immobilized (Wild Charge - Bear)
	        102359, // "Root",		-- Mass Entanglement
	        110693, // "Root",		-- Frost Nova (Mage)
	        19185,  // "Root",		-- Entrapment
	        128405, // "Root",		-- Narrow Escape
	        90327,  // "Root",		-- Lock Jaw (Dog)
	        50245,  // "Root",		-- Pin (Crab)
	        54706,  // "Root",		-- Venom Web Spray (Silithid)
	        4167,   // "Root",		-- Web (Spider)
	        122,    // "Root",		-- Frost Nova
	        111340, // "Root",		-- Ice Ward
	        33395,  // "Root",		-- Freeze
	        116706, // "Root",		-- Disable
	        113275, // "Root",		-- Entangling Roots (Symbiosis)
	        123407, // "Root",		-- Spinning Fire Blossom
	        113275, // "Root",		-- Entangling Roots (Symbiosis)
	        87194,  // "Root",		-- Glyph of Mind Blast
	        114404, // "Root",		-- Void Tendril's Grasp
	        115197, // "Root",		-- Partial Paralysis
	        64695,  // "Root",		-- Earthgrab (Earthgrab Totem)
	        63685,  // "Root",		-- Freeze (Frozen Power)
	        107566, // "Root",		-- Staggering Shout
	        39965,  // "Root",		-- Frost Grenade
	        55536,  // "Root",		-- Frostweave Net
	        13099,  // "Root",		-- Net-o-Matic
            136634  //http://www.wowdb.com/spells/109298-narrow-escape
        };

        public static double Rooted(WoWUnit u)
        {
            if (u == null || !u.IsValid || !u.IsAlive)
                return 0.0;

            WoWAuraCollection auras = u.GetAllCachedAuras();
            WoWAura longestDebuff = auras.Where(a => RootList.Contains(a.SpellId)).OrderBy(a => a.TimeLeft).FirstOrDefault();

            if (longestDebuff == null)
            {
                return 0.0;
            }
            return longestDebuff.TimeLeft.TotalMilliseconds;

        }

        public static readonly HashSet<int> SootheList = new HashSet<int>
            {
            49016, // Unholy Frenzy
            93099, // Vengeance ( Death Knight )
            84840, // Vengeance ( Druid )
            84840, // Vengeance ( Paladin )
            93098, // Vengeance ( Warrior )
            5229, // Enrage
            52610, // Savage Roar
            48393, // Owlkin Frenzy
            18499, // Berserker Rage
            56611, // Wrecking Crew
            13046, // Enrage
            12292, // Bloodbath

        };

        public static double HasEnrages(WoWUnit u)
        {
            if (u == null || !u.IsValid || !u.IsAlive)
                return 0;

            WoWAura longestDebuff = u.Auras.Values.Where(a => SootheList.Contains(a.SpellId)).OrderBy(a => a.TimeLeft).FirstOrDefault();

            if (longestDebuff == null)
            {
                return 0;
            }
            // MAD.StandardLog("DebuffRootCanCleanse: " + longestDebuff.Name + " - " + longestDebuff.SpellId);
            return longestDebuff.TimeLeft.TotalMilliseconds;

        }

        #endregion

        #region Breakable effects

        public static readonly HashSet<int> BreakableList = new HashSet<int>
            {
            2637, //Hibernate
            3355, // Freezing Trap Effect
            19503, // Scatter Shot
            90337, // Bad Manner (Monkey)
            126246, // Lullaby (Crane)
            19386, // Wyvern Sting
            118, // Polymorph
            20066, // Repentance
            2094, // Blind
            1776, // Gouge
            6770, // Sap
            76780, // Blind Elemental
            6358, // Seduction ( Succubus )
            115268 // Mesmerize

        };

        public static double BreakOnDamage(WoWUnit u)
        {
            if (u == null || !u.IsValid || !u.IsAlive)
                return 0;

            WoWAuraCollection auras = u.GetAllCachedAuras();
            WoWAura longestDebuff = auras.Where(a => BreakableList.Contains(a.SpellId)).OrderBy(a => a.TimeLeft).FirstOrDefault();

            if (longestDebuff == null || !BreakableList.Contains(longestDebuff.SpellId))
            {
                return 0;
            }
            return longestDebuff.TimeLeft.TotalMilliseconds;

        }

        #endregion

        #region Silence effects

        public static readonly HashSet<int> SilenceList = new HashSet<int>
            {
            47476, // Strangulate
            114238, // Fae Silence (Glyph of Fae Silence)
            81261, // Solar Beam
            34490, // Silencing Shot
            102051, // Frostjaw (also a root)
            55021, // Silenced - Improved Counterspell
            116709, // Spear Hand Strike
            31935, // Avenger's Shield
            15487, // Silence
            15487, // Silence
            1330, // Garrote - Silence
            1330, // Garrote - Silence
            113287, // Solar Beam (Symbiosis)
            31117, // Unstable Affliction
            24259, // Spell Lock (Felhunter/Observer)
            18498, // Silenced - Gag Order
            25046, // Arcane Torrent (Energy)
            28730, // Arcane Torrent (Mana)
            50613, // Arcane Torrent (Runic Power)
            69179, // Arcane Torrent (Rage)
            80483, // Arcane Torrent (Focus)
            129597, // Arcane Torrent (Chi)

        };

        public static double Silenced(WoWUnit u)
        {
            if (u == null || !u.IsValid || !u.IsAlive)
                return 0;

            WoWAuraCollection auras = u.GetAllCachedAuras();
            WoWAura longestDebuff = auras.Where(a => SilenceList.Contains(a.SpellId)).OrderBy(a => a.TimeLeft).FirstOrDefault();

            if (longestDebuff == null)
            {
                return 0;
            }
            // MAD.StandardLog("DebuffRootCanCleanse: " + longestDebuff.Name + " - " + longestDebuff.SpellId);
            return longestDebuff.TimeLeft.TotalMilliseconds;

        }

        #endregion

        #region Tranquilizign Shot
        public static readonly HashSet<int> TranqList = new HashSet<int>
            {
          //  17,//http://www.wowdb.com/spells/17-power-word-shield
          //  18499, //http://www.wowdb.com/spells/18499-berserker-rage
          //  12472,//http://www.wowdb.com/spells/12472-icy-veins
          //  11426, //http://www.wowdb.com/spells/11426-ice-barrier
            6940, //http://www.wowdb.com/spells/6940-hand-of-sacrifice
            1044, //http://www.wowdb.com/spells/1044-hand-of-freedom
          // 53271,//http://www.wowdb.com/spells/53271-masters-call
            1022,//http://www.wowdb.com/spells/1022-hand-of-protection
            10060, // http://www.wowhead.com/spell=10060 Power Infusion
          //  13046, // http://www.wowhead.com/spell=13046 Enrage
            16974, // http://www.wowhead.com/spell=16974 Predatory Swiftness

        };

        public static bool CanBeTranquilized(WoWUnit u, double time)
        {
            if (u == null || !u.IsValid || !u.IsAlive)
                return false;

            WoWAura longestDebuff = u.Auras.Values.Where(a => TranqList.Contains(a.SpellId)).OrderBy(a => a.TimeLeft).FirstOrDefault();

            return longestDebuff != null && longestDebuff.TimeLeft.TotalMilliseconds > time;
        }
        #endregion

        /// <summary>
        /// Casting Checks
        /// </summary>
        
        #region Can Cast
        public static readonly HashSet<int> CannotCast = new HashSet<int>
            {
            123812,// http://www.wowdb.com/spells/123812-pheromones-of-zeal
            115003,// http://www.wowdb.com/spells/115003-carbonation
            119601,// http://www.wowdb.com/spells/119601-bitter-thoughts
            9256// http://www.wowdb.com/spells/9256-deep-sleep
        };

        public static readonly HashSet<int> PetCanCast = new HashSet<int>
            {
            130392,// http://www.wowhead.com/spell=13n0392 // Blink Strikes
            120697,// http://www.wowhead.com/spell=120697 // Lynx Rush
            34026// http://www.wowhead.com/spell=34026 // Kill Command
        };
        #endregion

        #region No Cooldown
        public static readonly HashSet<int> NoCooldown = new HashSet<int>
            {
           3044,// http://www.wowdb.com/spells/3044-arcane-shot
           1130,// http://www.wowdb.com/spells/1130-hunters-mark
           1978,// http://www.wowdb.com/spells/1978-serpent-sting
           136,//http://www.wowdb.com/spells/136-mend-pet
           19801,//http://www.wowdb.com/spells/19801-tranquilizing-shot
           82692,//http://www.wowdb.com/spells/82692-focus-fire
           82654,//http://www.wowdb.com/spells/82654-widow-venom
           883,//http://www.wowdb.com/spells/883-call-pet-1
           83242,//http://www.wowdb.com/spells/83242-call-pet-2
           83243,//http://www.wowdb.com/spells/83243-call-pet-3
           83244,//http://www.wowdb.com/spells/83244-call-pet-4
           83245//http://www.wowdb.com/spells/83245-call-pet-5
        };
        #endregion

        #region No Explosive on ST
        public static readonly HashSet<int> NoExplosiveST = new HashSet<int>
            {
           60410,
        };
        #endregion

        #region No Global Cooldown
        public static readonly HashSet<int> GCDFree = new HashSet<int>
            {
           19574,//http://www.wowdb.com/spells/19574-bestial-wrath
           3045,//http://www.wowdb.com/spells/3045-rapid-fire
           23989,//http://www.wowdb.com/spells/23989-readiness
           781,//http://www.wowdb.com/spells/781-disengage
           109304,//http://www.wowdb.com/spells/109304-exhilaration
           5384,//http://www.wowdb.com/spells/5384-feign-death
           82726,//http://www.wowdb.com/spells/82726-fervor
           19577,//http://www.wowdb.com/spells/19577-intimidation
           77769,//http://www.wowdb.com/spells/77769-trap-launcher
           53271,//http://www.wowdb.com/spells/53271-masters-call
           // *Racial Skills*
           59752,//http://www.wowdb.com/spells/59752-every-man-for-himself
           20594,//http://www.wowdb.com/spells/20594-stoneform
           58984,//http://www.wowdb.com/spells/58984-shadowmeld
           59544,//http://www.wowdb.com/spells/59544-gift-of-the-naaru
           20572,//http://www.wowdb.com/spells/20572-blood-fury
           26297,//http://www.wowdb.com/spells/26297-berserking
           80483//http://www.wowdb.com/spells/80483-arcane-torrent
        };
        #endregion

        #region Should Halt - User Controlled
        public static readonly HashSet<int> HoldList = new HashSet<int>
            {
            1499,//http://www.wowdb.com/spells/1499-freezing-trap
            19386,//http://www.wowdb.com/spells/19386-wyvern-sting
            19503,//http://www.wowdb.com/spells/19503-scatter-shot
            90337,//http://www.wowdb.com/spells/90337-bad-manner
            136634, //http://www.wowdb.com/spells/109298-narrow-escape

        };

        public static bool ShouldHold(WoWUnit u)
        {
            if (u == null || !u.IsValid || !u.IsAlive)
                return false;

            WoWAura activeaura = u.Auras.Values.Where(a => HoldList.Contains(a.SpellId)).OrderBy(a => a.TimeLeft).FirstOrDefault();

            return activeaura != null;
        }

        #endregion

        #region CanCastWhileMoving
        public static readonly HashSet<string> CanCastWhileMoving = new HashSet<string>
            {
          "Cobra Shot",
          "Steady Shot"
        };
        #endregion
        /// <summary>
        /// Bosslists and Checks
        /// </summary>
        
        #region Training Dummys
        public static HashSet<ulong> TrainingDummies
        {
            get
            {
                return Dummies;
            }
        }
        private static readonly HashSet<ulong> Dummies = new HashSet<ulong>
            {
            31146, // Raider's
            54344, // Highlord's Nemesis Trainer (Ebon Hold)
            46647, // 81-85
            32546, // Ebon Knight's (DK)
            31144, // 79-80
            32543, // Veteran's (Eastern Plaguelands)
            32667, // 70
            32542, // 65 EPL
            32666, // 60
            30527, // ?? Boss one (no idea?)
            67127, // MoP Trainings Dummy
            88375, // Turnip Punching Bag
            };
        #endregion

        #region MoP Bosses
        private static readonly HashSet<ulong> Bosses = new HashSet<ulong>
            {
            // Patch 5.0 - MoP Bosses ============================
            
            // Throne of Thunder (5.2)
            69465, // Jin'rokh the Breaker
            68476, // Horridon
            69131, // Council of Elders
            69132, // Council of Elders
            69134, // Council of Elders
            69078, // Council of Elders
            67977, // Tortos
            70229, // Megaera
            70250, // Megaera
            70251, // Megaera
            69712, // Ji-Kun
            68036, // Durumu the Forgotten
            69017, // Primordius
            68078, // Iron Qon
            68905, // Twin Consorts
            68904, // Twin Consorts

            // Temple of the Jade Serpent http://mop.wowhead.com/zone=5956#npcs
            56448, // Wise Mari <Waterspeaker>
            58826, // Zao Sunseeker <Champion of the Five Suns>
            59051, // Strife
            59726, // Peril
            56732, // Liu Flameheart <Priestess of the Jade Serpent>
            56762, // Yu'lon <The Jade Serpent>
            56439, // Sha of Doubt
                       
            // Stormstout Brewery http://mop.wowhead.com/zone=5963#npcs
            56637, // Ook-Ook 
            56717, // Hoptallus
            59479, // Yan-Zhu the Uncasked
            
            // Shado-Pan Monastery http://mop.wowhead.com/zone=5918#npcs
            56747, // Gu Cloudstrike
            56754, // Azure Serpent, Phase 2 of Gu Cloudstrike
            56541, // Master Snowdrift
            56719, // Sha of Violence
            56884, // Taran Zhu <Lord of the Shado-Pan>
            
            // Gate of the Setting Sun http://mop.wowhead.com/zone=5976#npcs
            56906, // Saboteur Kip'tilak
            56589, // Striker Ga'dok
            56636, // Commander Ri'mok
            61177, // Raigonn
            56877, // Raigonn
            56895, // Raigonn
            
            // Mogu'shan Palace http://www.wowhead.com/zone=6182
            61442, // Kuai the Brute
            61444, // Ming the Cunning
            61445, // Haiyan the Unstoppable
            61243, // Gekkan
            61337, // Glintrok Ironhide
            61338, // Glintrok Skulker
            61339, // Glintrok Oracle
            61340, // Glintrok Hexxer
            61398, // Xin the Weaponmaster <King of the Clans>
            
            // Siege of Niuzao Temple http://mop.wowhead.com/zone=6214#npcs
            61567, // Vizier Jin'bak
            61634, // Commander Vo'jak
            61485, // General Pa'valak
            62205, // Wing Leader Ner'onok

            // Scarlet Halls http://www.wowhead.com/zone=6052
            59303, // Houndsmaster Braun
            58632, // Armsmaster Harlan
            59150, // Flameweaver Koegler

            // Scarlet Monastry http://www.wowhead.com/zone=6109
            59789, // Thalnos the Soulrender
            59223, // Brother Korloff
            3977, // High Inquisitor Whitemane
            60040, // Commander Durand
            59191, // Commander Lindon
            59303, // Houndmaster Braun

            // Scholomance http://www.wowhead.com/zone=6066
            58633, // Instructor Chillheart
            59184, // Jandice Barov
            59153, // Rattlegore
            58722, // Lilian Moss
            59080, // Darkmaster Gandling
            59359, // Flesh Horror
            59193, // Boneweaver
            
            // POSSIBLE DUNGEONS
            // Crypt of Forgotten Kings
            // The Perfect Storm
            // Temple of the Red Crane
            // Temple of the White Tiger
            
            // Mogu'shan Vaults
            60047, // Amethyst Guardian
            60051, // Cobalt Guardian
            60043, // Jade Guardian
            59915, // Jasper Guardian
            60009, // Feng the Accursed <Keeper of Champion Spirits>
            60143, // Gara'jal the Spiritbinder
            61429, // Meng the Demented <Mad King>
            61421, // Zian of the Endless Shadow
            61423, // Qiang the Merciless
            61427, // Subetai the Swift
            60397, // Emperor's Strength
            60410, // Elegon
            60400, // Jan-xi <Emperor's Open Hand>
            60399, // Qin-xi

            // Heart of Fear
            66791, // Imperial Vizier Zor'lok <Voice of the Empress>
            62543, // Blade Lord Ta'yak
            62164, // Garalon
            65501, // Wind Lord Mel'jarak
            62402, // Kor'thik Elite Blademaster
            62405, // Sra'thik Amber-Trapper
            62408, // Zar'thik Battle-Mender
            63666, // Amber-Shaper Un'sok
            62837, // Grand Empress Shek'zeer
            
            // Terrace of Endless Spring
            60583, // Protector Kaolan
            60586, // Elder Asani
            60585, // Elder Regail
            60491, // Sha of Anger
            62346, // Galleon
            62442, // Tsulong
            63099, // Lei Shi
            60999, // Sha of Fear
        };

        #endregion

        public static uint HasteBuffs()
        {
            uint count = 0;

            if (StyxWoW.Me.HasAura("Rapid Fire"))
            {
                count += 40;
            }

            if (StyxWoW.Me.HasAura("Berserking"))
            {
                count += 20;
            }

            if (StyxWoW.Me.HasCachedAura("Focus Fire"))
            {
                count += StyxWoW.Me.CachedStackCount("Focus Fire") * 6;
            }

            if (StyxWoW.Me.HasAnyCachedAura(new[] {"Ancient Hysteria", "Time Warp", "Bloodlust", "Heroism"}))
            {
                count += 30;
            }

            return count;
        }

        public static bool TargetIsBoss(WoWUnit unit)
        {
            return unit != null && (unit.IsBoss || BossIds.Contains(unit.Entry) || TrainingDummies.Contains(unit.Entry));
        }

        static Lists()
        {
            foreach (var bossId in Dummies)
            {
                Bosses.Add(bossId);
            }
        }

        public static HashSet<ulong> BossIds
        {
            get { return Bosses; }
        }
    }
}
