﻿#region Author Information

// // Mark II - Logger.cs
// // Created on 12/04/2013 at 19:03 Uhr
// // Author: Mirabis - Moreno Sint Hill
// 

#endregion

using System;
using System.Windows.Media;
using Styx.Common;

namespace MarkII.Misc
{
    public static class Logger
    {
        //Prevent double logging
        private static string _lastDebugmsg;
        private static string _lastFailmsg;
        private static string _lastItemmsg;


        public static void InitLog(string message, params object[] args)
        {
            if (message == null) return;
            Logging.Write(Colors.MediumSeaGreen, "[" + DateTime.Now.ToString("ss:fff") + "] " + message, args);
        }

        public static void ItemLog(string message, params object[] args)
        {
            if (message == _lastItemmsg) return;
            Logging.Write(Colors.DodgerBlue, "[" + DateTime.Now.ToString("ss:fff") + "] " + message, args);
            _lastItemmsg = message;
        }

        public static void FailLog(string message, params object[] args)
        {
            if (message == _lastFailmsg) return;
            Logging.Write(Colors.DarkOrange, "[" + DateTime.Now.ToString("ss:fff") + "] " + message, args);
            _lastFailmsg = message;
        }

        public static void CombatLog(string message, params object[] args)
        {
            if (message == null) return;
            Logging.Write(Colors.LightGray, "[" + DateTime.Now.ToString("ss:ff") + "] " + message, args);
        }

        public static void CancelLog(string message, params object[] args)
        {
            if (message == null) return;
            Logging.Write(Colors.MediumVioletRed, "[" + DateTime.Now.ToString("ss:ff") + "] " + message, args);
        }

        public static void DispelLog(string message, params object[] args)
        {
            if (message == null) return;
            Logging.Write(Colors.Purple, "[" + DateTime.Now.ToString("ss:ff") + "] " + message, args);
        }

        public static void TargetLog(string message, params object[] args)
        {
            if (message == null) return;
            Logging.Write(Colors.SaddleBrown, "[" + DateTime.Now.ToString("ss:fff") + "] " + message, args);
        }

        public static void DebugLog(string message, params object[] args)
        {
            if (message == _lastDebugmsg) return;
            Logging.Write(LogLevel.Diagnostic, Colors.Firebrick, "[" + DateTime.Now.ToString("ss:fff") + "] " + message,
                          args);
            _lastDebugmsg = message;
        }
    }
}