﻿#region Author Information

// // Mark II - SurvivalPvP.cs
// // Created on 12/04/2013 at 19:05 Uhr
// // Author: Mirabis - Moreno Sint Hill
// 

#endregion

using System;
using MarkII.Managers;
using MarkII.Misc;
using MarkII.Settings;
using CommonBehaviors.Actions;
using Styx;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using Action = Styx.TreeSharp.Action;
using CM = MarkII.Managers.CastManager;

namespace MarkII.Rotations
{
    public class SurvivalPvP
    {
        //Not Implemented

        #region Priority : Combat Selector

        private static Composite CombatSelector
        {
            get
            {
                return new PrioritySelector(
                    Helpers.TreePerformance("SurvivalPvP"),
                    AutoPause(),
                    new Decorator(ret => !HotkeyManager.Registered, new Action(ret => HotkeyManager.RegisterKeys())),
                    new Throttle(1, TimeSpan.FromSeconds(1), Helpers.AcquireTargets),
                    CM.WaitForGcdOrCastOrChannel(), // Return if Casting/Channeling ( Traverse Successor )
                    new Decorator(req => Unit.ValidUnit(Target, true, false), //Valid Target
                                  new PrioritySelector(
                                      new Throttle(Items.UseItems),
                                      PetManager.CreateHunterCallPetBehavior(),
                                      DefensiveCooldowns,
                                      CrowdControl(when => true),
                                      HotkeyBehavior(when => true),
                                      PetManager.CreateCastPetActionOn("Attack", on => Target),
                                      Interrupt(req => true),
                                      FocusRegen(when => HotkeyManager.RegenMode),
                                      //Normally we go down here ; )
                                      new Decorator(when => !HotkeyManager.RegenMode,
                                                    //BUG: Pretty Redundant if we already check this on FocusRegen
                                                    new PrioritySelector(
                                                        OffensiveCooldowns(when => true),
                                                        TrapBehavior(when => true),
                                                        AreaofEffect(when =>HotkeyManager.AoEMode ||Helpers.AddCount(25, Target) >= MainSettings.AddCount),
                                                        SingleTarget))
                                      )));
            }
        }

        #endregion

        //Not Implemented

        #region Priority : Pre Combat Selector

        private static Composite PreCombatSelector
        {
            get
            {
                return new PrioritySelector(
                    PetManager.CreateHunterCallPetBehavior(), //BUG: Setting
                    CM.Cast("Hunter's Mark", ret => Target,
                               ret => /* MainSettings.HuntersMarkOOC &&*/
                               Target.Distance > 40 && Target.Distance < 100 &&
                               (Me.CurrentMap.IsArena || Me.CurrentMap.IsBattleground) &&
                               !Target.HasMyCachedAura("Hunter's Mark"))
                    );
            }
        }

        #endregion

        //Not Implemented

        #region Rotation Handler : Defensive Cooldowns

        private static Composite DefensiveCooldowns
        {
            get
            {
                return new PrioritySelector(
                    );
            }
        }

        #endregion

        //Not Implemented

        #region Rotation Handler : OffensiveCooldowns

        private static Composite OffensiveCooldowns(Main.Selection<bool> reqs = null)
        {
            return new Decorator(when => reqs == null || reqs(when),
                                 new PrioritySelector(
                                     ));
        }

        #endregion

        //Not Implemented

        #region Rotation Handler : HotkeyBehavior

        private static Composite HotkeyBehavior(Main.Selection<bool> reqs = null)
        {
            return new Decorator(when => reqs == null || reqs(when),
                                 new PrioritySelector(
                                     //TODO: Nothing here?
                                     ));
        }

        #endregion

        //Not Implemented

        #region Rotation Handler : Crowd Control

        private static Composite CrowdControl(Main.Selection<bool> reqs = null)
        {
            return new Decorator(when => reqs == null || reqs(when),
                                 new PrioritySelector(
                                     ));
        }

        #endregion

        //Not Implemented

        #region Rotation Handler : Interrupt

        private static Composite Interrupt(Main.Selection<bool> reqs = null)
        {
            return new Decorator(when => reqs == null || reqs(when),
                                 new PrioritySelector(
                                     ));
        }

        #endregion

        //Not Implemented

        #region Rotation Handler : FocusRegen

        private static Composite FocusRegen(Main.Selection<bool> reqs = null)
        {
            return new Decorator(when => reqs == null || reqs(when),
                                 new PrioritySelector(
                                     ));
        }

        #endregion

        //Not Implemented

        #region Rotation Handler : TrapBehavior

        private static Composite TrapBehavior(Main.Selection<bool> reqs = null)
        {
            return new Decorator(when => reqs == null || reqs(when),
                                 new PrioritySelector(
                                     new Decorator(ret => Target.Distance > 5 && Target.Distance < 40,
                                                   new PrioritySelector(
                                                       )),
                                     new Decorator(ret => Target.Distance <= 5,
                                                   new PrioritySelector(
                                                       ))));
        }

        #endregion

        //Not Implemented

        #region Rotation Handler : Single Target

        private static Composite SingleTarget
        {
            get
            {
                return new PrioritySelector(
                    );
            }
        }

        #endregion

        //Not Implemented

        #region Rotation Handler : Area of Effect

        private static Composite AreaofEffect(Main.Selection<bool> reqs = null)
        {
            return new Decorator(when => reqs == null || reqs(when),
                                 new PrioritySelector(
                                     ));
        }

        #endregion

        //Not Implemented

        #region Ext :

        public static Composite CreateCombat
        {
            get { return CombatSelector; }
        }

        public static Composite CreatePrecombat
        {
            get { return PreCombatSelector; }
        }

        public static Composite HoldOn(WoWUnit u, bool enemy, bool friendly)
        {
            return new Decorator(ret => !Unit.ValidUnit(u, enemy, friendly) || Lists.ShouldHold(u),
                                 new ActionAlwaysSucceed());
        }

        public static Composite AutoPause()
        {
            return new Decorator(ret => Me.HasAnyCachedAura(new[] {"Drink", "Food", "First Aid", "Feign Death"}),
                                 new ActionAlwaysSucceed());
        }

        /*
                private static WoWUnit MDTarget()
                {
                    switch (MainSettings.MisdirectOn)
                    {
                        case MisdirectOn.Me:
                            return StyxWoW.Me;
                        case MisdirectOn.Focus:
                            return Unit.ValidFocus(false, true) ? Focus : null;
                        case MisdirectOn.Pet:
                            return Me.GotAlivePet ? Pet : null;
                        case MisdirectOn.Nobody:
                            return null;

                    }
                    return null;
                }
        */

        #endregion

        //Not Implemented

        #region Tidy : Bools

        #endregion

        //Not Implemented

        #region Tidy: Calls

        private static WoWUnit Target
        {
            get { return StyxWoW.Me.CurrentTarget; }
        }

        private static LocalPlayer Me
        {
            get { return StyxWoW.Me; }
        }

        private static MainSettingsSV MainSettings
        {
            get { return MainSettingsSV.Instance; }
        }

        #endregion

    }
}