﻿using System.ComponentModel;
using Styx;
using Styx.Common;
using Styx.Helpers;

namespace MarkII.Settings
{
     internal class CooldownSettings : Styx.Helpers.Settings
    {
         private static CooldownSettings _instance;
         public static CooldownSettings Instance
        {
            get { return _instance ?? (_instance = new CooldownSettings()); }
        }

        public CooldownSettings()
            : base(SettingsPath + ".config")
        {
        }

        private static string SettingsPath
        {
            get
            {
                return string.Format("{0}\\Settings\\MarkI\\MarkISettings_Cooldowns_{1}", Utilities.AssemblyDirectory,
                                     StyxWoW.Me.Name);
            }
        }

        #region Cooldowns

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("Cooldowns")]
        [DisplayName("Rapid Fire")]
        [Description("Use Rapid Fire")]
        public bool RapidFire { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("Cooldowns")]
        [DisplayName("Bestial Wrath")]
        [Description("Use Bestial Wrath")]
        public bool BestialWrath { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("Cooldowns")]
        [DisplayName("Racial Skill")]
        [Description("Use Racial Skill")]
        public bool Racial { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(false)]
        [Category("Cooldowns")]
        [DisplayName("Readiness")]
        [Description("Use Readiness")]
        public bool Readiness { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("Cooldowns")]
        [DisplayName("Stampede")]
        [Description("Use Stampede")]
        public bool Stampede { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(false)]
        [Category("Cooldowns")]
        [DisplayName("Lifeblood")]
        [Description("Use Lifeblood (Herbalism)")]
        public bool Lifeblood { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("Cooldowns")]
        [DisplayName("Gloves Enchant")]
        [Description("Use Gloves Enchant (Engineering)")]
        public bool Gloves { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(false)]
        [Category("Cooldowns")]
        [DisplayName("Belt Enchant")]
        [Description("Use Belt Enchant (Engineering)")]
        public bool Belt { get; set; }


        #endregion
    }
}
