﻿using System.ComponentModel;
using MarkII.Misc;
using Styx;
using Styx.Common;
using Styx.Helpers;

namespace MarkII.Settings
{
    internal class PetSettingsPvP : Styx.Helpers.Settings
    {
        private static PetSettingsPvP _instance;
        public static PetSettingsPvP Instance
        {
            get { return _instance ?? (_instance = new PetSettingsPvP()); }
        }

        public PetSettingsPvP()
            : base(SettingsPath + ".config")
        {
        }

        private static string SettingsPath
        {
            get
            {
                return string.Format("{0}\\Settings\\MarkI\\MarkISettings_PetPvP_{1}", Utilities.AssemblyDirectory,
                                     StyxWoW.Me.Name);
            }
        }

        #region Petstuff
        [Setting]
        [Styx.Helpers.DefaultValue(CallPet.None)]
        [Category("Pets")]
        [DisplayName("Call pet")]
        [Description("Which pet to call, if any.")]
        public CallPet CallPet { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(false)]
        [Category("Pets")]
        [DisplayName("Revive Pet")]
        [Description("Use Revive Pet")]
        public bool RevivePet { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(false)]
        [Category("Pets")]
        [DisplayName("Combat Only")]
        [Description("Use Call and Revive Pet only in Combat")]
        public bool CombatOnly { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(false)]
        [Category("Pets")]
        [DisplayName("Mend Pet")]
        [Description("Use Mend Pet")]
        public bool MendPet { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(65)]
        [Category("Pets")]
        [DisplayName("Pet Health")]
        [Description("Less than % health on pet to use Mend Pet")]
        public int PetHealth { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(SpiritMend.Never)]
        [Category("Pets")]
        [DisplayName("Spirit Mend")]
        [Description("Who to use Spirit Mend on.")]
        public SpiritMend SpiritMend { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(80)]
        [Category("Pets")]
        [DisplayName("My Health")]
        [Description("Less than % health on Me to use Spirit Mend")]
        public int SpiritHealMe { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(30)]
        [Category("Pets")]
        [DisplayName("Pet Health")]
        [Description("Less than % health on pet to use Spirit Mend")]
        public int SpiritHealPet { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(50)]
        [Category("Pets")]
        [DisplayName("Focus Health")]
        [Description("Less than % health on Focus to use Spirit Mend")]
        public int SpiritHealFocus { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(50)]
        [Category("Pets")]
        [DisplayName("Arena Partner Health")]
        [Description("Less than % health on Arena Partner to use Spirit Mend")]
        public int SpiritHealPartner { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(RoarOfSacrifice.Never)]
        [Category("Pets")]
        [DisplayName("Roar of Sacrifice")]
        [Description("Who to use Roar of Sacrifice on.")]
        public RoarOfSacrifice RoarOfSacrifice { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(50)]
        [Category("Pets")]
        [DisplayName("My Health")]
        [Description("Less than % health on Me to use Roar of Sacrifice")]
        public int RoSMe { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(50)]
        [Category("Pets")]
        [DisplayName("Arena Partner Health")]
        [Description("Less than % health on Arena Partner to use Roar of Sacrifice")]
        public int RoSPartner { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("Pets")]
        [DisplayName("Bullheaded")]
        [Description("Use Bullheaded")]
        public bool Bullheaded { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("Pets")]
        [DisplayName("Rabid")]
        [Description("Use Rabid")]
        public bool Rabid { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("Pets")]
        [DisplayName("Pet Attack")]
        [Description("Attack Current Target")]
        public bool PetAttack { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("Pets")]
        [DisplayName("Web Spray")]
        [Description("Use Silithid: Venom Web Spray")]
        public bool WebSpray { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("Pets")]
        [DisplayName("Lullaby on Focus")]
        [Description("Use Lullaby on Focused Unit")]
        public bool Lullaby { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("Pets")]
        [DisplayName("Lullaby to Interrupt")]
        [Description("Use Lullaby on Target to Interrupt the Unit")]
        public bool LullabyInt { get; set; }
        #endregion

    }
}
