﻿using System.ComponentModel;
using MarkII.Misc;
using Styx;
using Styx.Common;
using Styx.Helpers;

namespace MarkII.Settings
{
    internal class PetSettingsSV : Styx.Helpers.Settings
    {
        private static PetSettingsSV _instance;
        public static PetSettingsSV Instance
        {
            get { return _instance ?? (_instance = new PetSettingsSV()); }
        }

        public PetSettingsSV()
            : base(SettingsPath + ".config")
        {
        }

        private static string SettingsPath
        {
            get
            {
                return string.Format("{0}\\Settings\\MarkI\\MarkISettings_PetSV_{1}", Utilities.AssemblyDirectory,
                                     StyxWoW.Me.Name);
            }
        }

        #region Petstuff
        [Setting]
        [Styx.Helpers.DefaultValue(CallPet.None)]
        [Category("Pets")]
        [DisplayName("Call pet")]
        [Description("Which pet to call, if any.")]
        public CallPet CallPet { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(false)]
        [Category("Pets")]
        [DisplayName("Revive Pet")]
        [Description("Use Revive Pet")]
        public bool RevivePet { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(false)]
        [Category("Pets")]
        [DisplayName("Combat Only")]
        [Description("Use Call and Revive Pet only in Combat")]
        public bool CombatOnly { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(false)]
        [Category("Pets")]
        [DisplayName("Mend Pet")]
        [Description("Use Mend Pet")]
        public bool MendPet { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(65)]
        [Category("Pets")]
        [DisplayName("Pet Health")]
        [Description("Less than % health on pet to use Mend Pet")]
        public int PetHealth { get; set; } 

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("Pets")]
        [DisplayName("Rabid")]
        [Description("Use Rabid")]
        public bool Rabid { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("Pets")]
        [DisplayName("Pet Attack")]
        [Description("Attack Current Target")]
        public bool PetAttack { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("Pets")]
        [DisplayName("Lullaby on Focus")]
        [Description("Use Lullaby on Focused Unit")]
        public bool Lullaby { get; set; }

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("Pets")]
        [DisplayName("Lullaby to Interrupt")]
        [Description("Use Lullaby on Target to Interrupt the Unit")]
        public bool LullabyInt { get; set; }
        #endregion

    }
}
